﻿
Option Explicit On

'#If 0
'#End If

NameSpace MakeDelf

Friend Class clsDelfGen




        ''' <summary>
        '''  '20.04.18 時点でのコーディング方向
        ''' 　　１．後でデバッグ・修正しやすくなるよう
        ''' 　　　　コードを「言語化」する。
        ''' 　　　　具体的にはIf分の中をクラスの関数化し、いかに簡単な if 文でも
        ''' 　　　　関数名で処理目的を言語化する。
        ''' 　　　　こんな感じでとにかく処理をクラスのサブルーチン化を行い
        ''' 　　　　とにかく「日本語的に」直感的に言語化する。
        '''
        '''  　 ２．親亀の追加・削除関数をとにかく共通化する。
        ''' 　　　　処理がめんどくさすぎて修正・コードが大変なので。
        ''' 　　　　
        ''' 　　　　１つの混在フレーム内に「１つのreffer」「１つのcash」という制約条件が
        ''' 　　　　崩壊して、仕様変更があったため、全面的にコードを見直す必要が発生している。
        ''' 　　　　　まず、Refferは連続して続く場合がある。
        ''' 　　　　　
        ''' 　　３．連結キャッシュのコード案が固まってない。
        ''' 　　４．HoleLength を使ってキャッシュ位置を決める時の処理がどうしたらいいか
        ''' 　　　　分からん。
        ''' 
        ''' 　　５．キャッシュ作成処理がバグだらけ。前後の混在フレームの有無の
        ''' 　　　　処理が甘過ぎる。　　　　　
        ''' 
        ''' 　　'20.04.21時点
        ''' 　　　　Kogame を載せる形式をやめてOyagameのメンバーに
        ''' 　　　　Reffers, RawData、Cashed のメンバを参照で入れる？？？
        ''' 　　　　データ構造が複雑過ぎるので・・・。
        ''' 
        ''' 
        ''' 
        ''' 
        ''' 　　　RawData フレーム
        ''' 　　　Cash フレーム(いらない？RawDataのまま？)
        ''' 　　　Reffer
        ''' 　　　
        ''' 　　　Cash + Reffer 
        '''       
        ''' 
        ''' 
        ''' 　　　　その他、Unzipd....に無いデータとして
        ''' 　　　　連結キャッシュがあるよな。
        ''' 
        ''' 
        ''' 
        ''' 　　　　RawData の一部を
        ''' 　　　　　　　Cash
        ''' 　　　　　　　Reffer 
        ''' 　　　　に変更する処理。
        ''' 　　　　Cash を RawDataに戻す処理
        ''' 　　　　のコード表現に偉いつまづいたわけだよな・・・。
        ''' 
        ''' 
        ''' 
        ''' 
        ''' </summary>
        ''' <remarks></remarks>


	Private Structure stFileList
		Dim FileName		As String
		Dim Path			As String
		Dim NativeFileName	As String
		Dim wExpandSize		As System.UInt16

		Dim bytData()		as Byte

	End Structure


        Friend Class clsByteKey
            Implements System.IEquatable(Of clsByteKey)
            Implements System.Collections.Generic.IEqualityComparer(Of clsByteKey)




            Friend low As Byte
            Friend high As Byte
            Friend blOneByte As Boolean

            ' パフォーマンス上の理由から引数なしの new を
            ' 構造体では指定できんらしい。やりたいならクラスに
            ' 変えればいいだけ、という事らしい。
            Sub New()
                Me.blOneByte = False
            End Sub

            Sub New(ByVal bytValue1 As Byte, ByVal bytValue2 As Byte)
                Me.low = bytValue1
                Me.high = bytValue2
                Me.blOneByte = False
            End Sub

            Sub New(ByVal objByteKey As clsByteKey)
                With objByteKey
                    Me.blOneByte = .blOneByte
                    Me.low = .low
                    Me.high = .high
                End With
            End Sub


            Friend Overloads Function Equals(ByVal other As clsByteKey) As Boolean _
            Implements System.IEquatable(Of clsByteKey).Equals

                If Me.low = other.low And _
                  Me.high = other.high And _
                  Me.blOneByte = other.blOneByte Then
                    Return True
                Else
                    Return False
                End If

            End Function


            Friend Overloads Function Equals(ByVal other As System.Object) As Boolean

                Dim objKey As clsByteKey

                objKey = DirectCast(other, clsByteKey)

                If Me.low = objKey.low And _
                  Me.high = objKey.high And _
                  Me.blOneByte = objKey.blOneByte Then
                    Return True
                Else
                    Return False
                End If
            End Function


            'Friend Shared Operator =( ByVal obj1 as clsByteKey, ByVal obj2 as clsByteKey ) as Boolean
            'End Operator

            'Public Function Equals1(ByVal x As clsByteKey, ByVal y As clsByteKey) As Boolean Implements System.Collections.Generic.IEqualityComparer(Of clsByteKey).Equals

            'End Function

            Public Function Equals1(ByVal x As clsByteKey, ByVal y As clsByteKey) As Boolean Implements System.Collections.Generic.IEqualityComparer(Of clsByteKey).Equals

                If x.low = y.low And _
                  x.high = y.high And _
                  x.blOneByte = y.blOneByte Then
                    Return True
                Else
                    Return False
                End If
            End Function

            Public Function GetHashCode1(ByVal obj As clsByteKey) As Integer Implements System.Collections.Generic.IEqualityComparer(Of clsByteKey).GetHashCode
                Return (obj.high << 8) Or Me.low
            End Function
        End Class


        ' CList<T> に以下クラスを入れればいい？
        ' 整数インデックスアクセス型で問題ないのかな？
        ' たぶん、ポインタオブジェクトインタンス参照型でないと
        ' 参照距離の解消が面倒だから…
        '
        ' 逆に、これだと、連結したり削除して
        ' ブロックを作り直した時に参照元が全部ズレるんだよなｗ
        ' つまり、「どこから参照されてます」一覧が必要、と。


        ' コードの簡素化を目的に
        ' Oyagame,KoGame を統合した新クラスを作ってみるｗ
        ' あまりに構造変更のコード量が増え過ぎる為。
        ' なんというムダ・・・。

        ' 今んとここんな感じ。
        '    RawData : Refed に clsFrame なし
        '    Cash    : Refed にあり
        '             RawOffset の長さ、位置に重複して置かれる
        '　　　　　　　１つの「save命令」をやるために
        '              最後のフレームにはEndFrameに clsFrame の最後を入れる？
        '
        '    Reffer  : Reffer に Cash 扱いの clsFrame を入れる？

        ' マルチフレームの種類
        ' 1.連結キャッシュにおける参照元・マルチフレーム : 
        '            : Reffer が並ぶ感じ？
        '
        ' 2.参照前引き伸ばしキャッシュ・マルチフレーム：
        '            : 参照フレームの途中にキャッシュがあるので
        '　            キャッシュを先頭に引き伸ばす感じ
        '              とりあえず、Cash-Reffer の順にフレームを置くべきか、
        '              Cash-Reffer の順にフレームを置くべきか・・・。微妙だｗ
        '
        ' 3.重なりキャッシュ・マルチフレーム：
        '           ： 複数の参照元から、このキャッシュの集まりのフレーム群を参照
        '
        ' 4.ショートRawを挟んだ Reffer-Raw-Reffer / Cash-Raw-Cash マルチフレーム
        '           ： 間にとても短い RawData フレームが入り、かつ
        '              アドレス的に連続参照可能なマルチフレーム
        '
        '
        '  上記の1.～4.が同時に起こり得る。
        '　・・・・ので、2.だけ特殊扱いにして、1.3.4だけ単独のマルチフレームに
        '  するｗ
        '
        ' マルチフレームとしては
        '    cashマルチ  (4.を含む)         cash同士は重複しても良い
        '    refferマルチ(4.を含む)         reffer同士は重複しない
        '
        ' 上記分類とは完全に別に、Reffer期間中にCashが挿入された場合に
        ' Cashの先頭がRefferの先頭まで扱いという「参照引き伸ばしキャッシュ」という
        ' 分類を用意する。(2.はマルチフレームのコードとは別にクラス機能を実装)
        '
        '
        ' 位置変更キャッシュつき参照フレーム
        '  ReplacedCashReffer
        '
        '  キャッシュと参照両方：RefferedReffer

        ' 連続自己参照のケースについては要検討？
        '
        '   

        Friend Class clsFrame

            Implements System.Collections.Generic.IComparer(Of clsFrame)


            Friend [Next] As clsFrame
            Friend Previous As clsFrame

            Friend RawOffSet As Integer

            Friend TopFrame As clsFrame
            Friend EndFrame As clsFrame
            Friend Reffered As System.Collections.Generic.List(Of clsFrame)
            Friend Reffer As clsFrame

            ' ヨソから参照されつつ、かつ自身も他を参照するReffer
            Friend RefferedReffer As clsFrame


            Friend Length As Integer        ' この clsFrame 単独の長さ
            Private mMultiLength As Integer      ' EndFrameまでの全体の長さ

            Friend Sub New()
                With Me
                    .Next = Nothing
                    .Previous = Nothing
                    .RawOffSet = -1
                    .TopFrame = Me
                    .EndFrame = Nothing
                    .Reffer = Nothing
                    .Reffered = Nothing
                    .RefferedReffer = Nothing
                    .Length = -1
                    .mMultiLength = -1
                    .EndFrame = Me
                End With
            End Sub

            ' 混在フレーム全体の長さ
            Friend ReadOnly Property WholeLength() As Integer
                Get
                    If Me.TopFrame Is Me And _
                       Me.EndFrame IsNot Me Then
                        Return Me.mMultiLength
                    End If


                    ' とりあえず先頭のフレームに全体の長さを入れとく。
                    Return TopFrame.WholeLength
                End Get
            End Property

            Friend ReadOnly Property RawOffsetEnd() As Integer
                Get
                    Return Me.RawOffSet + Me.Length
                End Get
            End Property


            Friend ReadOnly Property RawOffsetWholeEnd() As Integer
                Get
                    Return Me.RawOffSet + Me.WholeLength
                End Get
            End Property


            Friend ReadOnly Property IsRawData() As Boolean
                Get
                    ' 参照フレーム？
                    If Me.Reffer IsNot Nothing Then
                        Return False
                    End If

                    ' キャッシュフレーム？
                    If Me.Reffered IsNot Nothing Then
                        Return False
                    End If

                    Return True
                End Get
            End Property


            Friend ReadOnly Property IsCash() As Boolean
                Get
                    ' キャッシュフレーム？
                    If Me.Reffered IsNot Nothing Then
                        Return True
                    End If
                    Return False
                End Get
            End Property

            Friend ReadOnly Property IsReffer() As Boolean
                Get
                    ' 参照フレーム？
                    If Me.Reffer IsNot Nothing Then
                        Return True
                    End If
                    Return False
                End Get
            End Property

            Friend Sub SetPreNext(ByVal objPrevious As clsFrame, ByVal objNext As clsFrame)

                With Me
                    .Previous = objPrevious
                    .Next = objNext

                    If .Previous IsNot Nothing Then
                        .Previous.Next = Me
                    End If
                    If .Next IsNot Nothing Then
                        .Next.Previous = Me
                    End If
                End With

            End Sub

            Friend ReadOnly Property IsTopFrame() As Boolean
                Get
                    If Me.TopFrame Is Me Then
                        Return True
                    Else
                        Return False
                    End If
                End Get
            End Property

            Friend ReadOnly Property IsEndFrame() As Boolean
                Get
                    If Me.EndFrame Is Me Then
                        Return True
                    Else
                        Return False
                    End If
                End Get
            End Property

            Friend ReadOnly Property IsMultiFrame() As Boolean
                Get
                    If Me.TopFrame IsNot Me.EndFrame Then
                        Return True
                    Else
                        Return False
                    End If
                End Get
            End Property

            Friend ReadOnly Property IsRefferedRefferFrame() As Boolean
                Get
                    If Me.RefferedReffer IsNot Nothing Then
                        Return True
                    Else
                        Return False
                    End If
                End Get
            End Property


            Friend ReadOnly Property TopFrameRawOffset() As Integer
                Get
                    ' reffer 期間中に cash が入る場合は、cash が頭に来る。
                    If Me.IsRefferedRefferFrame Then

                        Dim nRawOffset As Integer
                        nRawOffset = System.Math.Min(Me.TopFrame.RawOffSet, _
                                                Me.RefferedReffer.TopFrame.RawOffSet)
                        Return nRawOffset
                    End If


                    Return Me.TopFrame.RawOffSet
                End Get
            End Property

            Friend Sub SetMeOnMutiCashessTop()

                Dim objCurrent As clsFrame
                Dim objEndFrame As clsFrame

                objCurrent = Me.Next

                objEndFrame = Me

                Do
                    If objCurrent Is Nothing Then
                        Exit Do
                    End If
                    If objCurrent.IsCash = False Then
                        Exit Do
                    End If

                    objCurrent.TopFrame = Me
                    objEndFrame = objCurrent

                    objCurrent = objCurrent.Next
                Loop

                objCurrent = Me.Next
                Me.EndFrame = objEndFrame
                Do
                    If objCurrent Is Nothing Then
                        Exit Do
                    End If
                    If objCurrent.IsCash = False Then
                        Exit Do
                    End If

                    objCurrent.EndFrame = objEndFrame

                    objCurrent = objCurrent.Next
                Loop


            End Sub


            Friend Function CompareToCashOffet_list(ByVal x As clsFrame, _
                                                    ByVal y As clsFrame) As Integer

                ' マルチキャッシュフレームの場合はどうするんだろ？

                ' マルチフレームの場合：
                ' (Cash) (Reffer)
                '   　
                ' (Cash) (Cash)
                '     この場合は複数のキャッシュが重なっているので…。
                '
                '
                '
                ' 今、作ってるのは。Reffer を入れたときにキャッシュフレームを
                ' 参照先に入れるわけだろ？
                ' で、参照先のキャッシュフレームを入れるために、RawPosから
                ' フレームを割り出すわけだろ？



                Return x(0).CashOffset.CompareTo(y(0).CashOffset)
            End Function

            Public Function Compare_RawOffset(ByVal x As clsFrame, ByVal y As clsFrame) As Integer Implements System.Collections.Generic.IComparer(Of clsFrame).Compare

            End Function
        End Class


        Friend MustInherit Class clsKoGame

            Friend Reffer As clsKoGame
            Friend Disabled As Boolean
            Friend DisabledReason As DisabledReasons
            Friend Parent As clsOyaGame

            Friend Enum DisabledReasons
                CanInCashIsFound
                CashInSameOyaGameIsMerged
                ' コスト高そうなので削除した。
                MaybeHighCostRefferCashIsDeleted
                ' キャッシュサイズを超えた循環キャッシュに全部キャッシュを使われたので
                ' Cash と Reffer を全部削除した。
                AddedCashIsOverCashSizeAndAlreadyAddedAllCashAndReffersAreDisabled
                ' キャッシュサイズを超えた循環キャッシュを足そうとしたがレベルが既存キャッシュより
                ' 低いので追加を諦めた。
                TriedAddingCashIsOverCashSizeButFailedToAddForThisCashIsLowetstDataLevel
                ' キャッシュ追加を試みたが、サイズオーバー。優先度の低いキャッシュの削除を試みたが
                ' 削除しようとするキャッシュ群のレベルの和の方が追加するキャッシュよりも
                ' 優先度が高いので追加を諦めた。
                TriedAddingCashIsCashSizeOverAndTringToDeleteCashesAreHigherDataLevelThanThigCash
                ' キャッシュをキャッシュイメージに追加しようとしたがサイズオーバー。
                ' 追加予定のキャッシュよりも優先度が低いので削除された。
                DeletedForCashIsOverAndThisRefferIsLowerDataLevelThanTryingAddedCash

                TriedAddingCashIsFailedForThisCashIsLowetstDataLevel
            End Enum
            'ライフタイムは？

            Friend Sub New()
                Me.Reffer = Nothing
                Me.Disabled = False
                Me.Parent = Nothing
            End Sub

            Friend Overridable ReadOnly Property IsClsRawData() As Boolean
                Get
                    Return False
                End Get
            End Property

            Friend Overridable ReadOnly Property IsClsReffer() As Boolean
                Get
                    Return False
                End Get
            End Property

            Friend Overridable ReadOnly Property IsClsCash() As Boolean
                Get
                    Return False
                End Get
            End Property


            Friend Overridable ReadOnly Property ToClsRawData() As clsRawData
                Get
                    Return Nothing
                End Get
            End Property

            Friend Overridable ReadOnly Property ToClsReffer() As clsReffer
                Get
                    Return Nothing
                End Get
            End Property


            Friend Overridable ReadOnly Property ToClsCash() As clsCashed
                Get
                    Return Nothing
                End Get
            End Property

            Friend Overridable Property Length() As Integer
                Get
                    Dim nLength As Integer

                    nLength = -1
                    If Me.IsClsRawData Then
                        nLength = Me.ToClsRawData.Length
                    ElseIf Me.IsClsReffer Then
                        nLength = Me.ToClsReffer.Length
                    ElseIf Me.IsClsCash Then
                        nLength = Me.ToClsCash.Length
                    End If
                    Return nLength
                End Get
                Set(ByVal nLength As Integer)

                    If Me.IsClsRawData Then
                        Me.ToClsRawData.Length = nLength
                    ElseIf Me.IsClsReffer Then
                        Me.ToClsReffer.Length = nLength
                    ElseIf Me.IsClsCash Then
                        Me.ToClsCash.Length = nLength
                    End If
                End Set
            End Property



            Friend Function CopyInstance() As clsKoGame

                Dim objNew As clsKoGame

                ' 多分派生クラスのメンバが呼ばれる筈なんだけど…。
                objNew = Me.CreateInstance()

                With objNew
                    .Reffer = Me.Reffer
                    .Disabled = Me.Disabled
                    .DisabledReason = Me.DisabledReason
                    .Parent = Me.Parent
                End With

                Return objNew
            End Function

            Friend MustOverride Function CreateInstance() As clsKoGame


        End Class

        Friend Class clsRawData
            Inherits clsKoGame
            Friend Pos As Integer
            Private mLength As Integer
            Friend Sub New()
                Me.Pos = -1
                Me.Length = -1
            End Sub


            Friend Overrides ReadOnly Property IsClsRawData() As Boolean
                Get
                    Return True
                End Get
            End Property

            Friend Overrides ReadOnly Property ToRawData() As clsRawData
                Get
                    Return Me
                End Get
            End Property

            Friend Overrides Property Length() As Integer
                Set( ByVal ｎLength as Integer )
                    Me.mLength = nLength
                End Set
                Get
                    Return Me.mLength
                End Get
            End Property

            Friend Overrides Function CreateInstance() As clsKoGame
                Dim objNew As New clsRawData()

                With objNew
                    .Pos = Me.Pos
                    .Length = Me.Length
                End With

                Return objNew
            End Function

        End Class

        Friend Class clsReffer
            Inherits clsKoGame
            Private mLength As Integer

            Friend FromOffset As Integer
            Friend ToOffset As Integer
            'Friend	RawOffset			As Integer
            

            Friend Overrides ReadOnly Property IsClsReffer() As Boolean
                Get
                    Return True
                End Get
            End Property

            Friend Overrides ReadOnly Property ToClsReffer() As clsReffer
                Get
                    Return Me
                End Get
            End Property

            Friend Overrides Property Length() As Integer
                Set( ByVal ｎLength as Integer )
                    Me.mLength = nLength
                End Set
                Get
                    Return Me.mLength
                End Get
            End Property


            Friend Overrides Function CreateInstance() As clsKoGame
                Dim objNew As New clsReffer()

                With objNew
                    .Length = Me.Length
                    .FromOffset = Me.FromOffset
                    .ToOffset = Me.ToOffset

                End With
                Return objNew
            End Function

        End Class

        Friend Class clsCashed
            Inherits clsKoGame
            Private mLength As Integer
            Friend RawOffset As Integer
            Friend CanInCashes As System.Collections.Generic.List(Of clsCashed)

            Private mReffereds As System.Collections.Generic.List(Of clsReffer)


            Friend CashPlacedPos As Integer

            Friend Sub New()
                MyBase.New()
                Me.CanInCashes = Nothing
                Me.CashPlacedPos = -1
            End Sub


            Friend Overrides ReadOnly Property IsClsCash() As Boolean
                Get
                    Return True
                End Get
            End Property

            Friend Overrides ReadOnly Property ToClsCash() As clsCashed
                Get
                    Return Me
                End Get
            End Property

            Friend Overrides Property Length() As Integer
                Set( ByVal ｎLength as Integer )
                    Me.mLength = nLength
                End Set
                Get
                    Return Me.mLength
                End Get
            End Property

            Friend ReadOnly Property IsSameCash(ByVal objCash As clsCashed) As Boolean
                Get
                    If Me.Length = objCash.Length And _
                     Me.RawOffset = objCash.RawOffset Then
                        Return True
                    End If
                    Return False
                End Get
            End Property

            Friend Sub AddCanInCash(ByVal objCash As clsCashed)
                If Me.CanInCashes Is Nothing Then
                    Me.CanInCashes = New System.Collections.Generic.List(Of clsCashed)(0)
                End If
                Me.CanInCashes.Add(objCash)
            End Sub

            Friend Sub AddReffed(ByVal objReffer As clsReffer)
                If Me.mReffereds Is Nothing Then
                    Me.mReffereds = New System.Collections.Generic.List(Of clsReffer)(0)
                End If
                Me.mReffereds.Add(objReffer)
            End Sub

            Friend Overloads Property Reffereds() As System.Collections.Generic.List(Of clsReffer)
                Set(ByVal value As System.Collections.Generic.List(Of clsReffer))
                    Me.mReffereds = value
                End Set
                Get
                    Return Me.mReffereds
                End Get
            End Property

            Friend ReadOnly Property IsPlacedCash() As Boolean
                Get
                    If Me.CashPlacedPos = -1 Then
                        Return False
                    End If

                    Return True
                End Get
            End Property

            Friend Overrides Function CreateInstance() As clsKoGame
                Dim objNew As New clsCashed()

                With objNew
                    .Length = Me.Length
                    .RawOffset = Me.RawOffset
                    .CanInCashes = Me.CanInCashes       ' 後でディープコピーに直す
                    .Reffereds = Me.mReffereds         ' 後でディープコピーに直す
                    .CashPlacedPos = Me.CashPlacedPos
                End With
                Return objNew
            End Function





        End Class

        Protected Class clsSave
            Inherits clsKoGame
            Private mLength As Integer

            Friend Overrides Property Length() As Integer
                Set( ByVal ｎLength as Integer )
                    Me.mLength = nLength
                End Set
                Get
                    Return Me.mLength
                End Get
            End Property


            Friend Overrides Function CreateInstance() As clsKoGame
                Dim objNew As New clsSave()

                With objNew
                    .Length = Me.Length
                End With
                Return objNew
            End Function

        End Class

        Friend Class clsOyaGame

            ' バイトデータ列
            ' 参照
            ' 保存命令
            ' キャッシュ化されたエリア
            ' いずれかを示す
            ' いずれも重複して置かれるのが問題…。


            ' これなんでいるんだっけ？？？
            Private pPre As clsOyaGame
            Private pNext As clsOyaGame

            Private mnRawPos As Integer
            Private mnRawPosEnd As Integer

            Friend KoGames As System.Collections.Generic.List(Of clsKoGame)


            Public Sub New()
                pPre = Nothing
                pNext = Nothing
                KoGames = New System.Collections.Generic.List(Of clsKoGame)(0)
                Call Me.DropLength()
            End Sub

            Friend Property Previous() As clsOyaGame
                Set(ByVal objOyaGame As clsOyaGame)
                    pPre = objOyaGame
                End Set
                Get
                    Return pPre
                End Get
            End Property

            ' for～Next とキーワード、予約語が被るため
            ' エスケープ識別子という物を使う
            '  http://mag.autumn.org/Content.modf?id=20031103132515
            Friend Property [Next]() As clsOyaGame
                Set(ByVal objOyaGame As clsOyaGame)
                    pNext = objOyaGame
                End Set
                Get
                    Return pNext
                End Get
            End Property

            Friend ReadOnly Property IsClsRawData() As Boolean
                Get
                    If Me.KoGames(0).IsClsRawData = True Then
                        Return True
                    End If
                End Get
            End Property

            Friend ReadOnly Property ToClsRawData() As clsRawData
                Get
                    Return Me.KoGames(0).ToRawData
                End Get
            End Property

            Default Friend ReadOnly Property Item(ByVal nKoGameNo As Integer) As clsKoGame
                Get
                    Return Me.KoGames(nKoGameNo)
                End Get
            End Property


            Protected Function GetLength() As Integer
                Dim nPos As Integer
                Dim nPosEnd As Integer

                Me.GetPositions(nPos, nPosEnd)
                Return nPosEnd - nPos + 1
            End Function

            Friend Sub DropLength()
                Me.mnRawPos = -1
                Me.mnRawPosEnd = -1
            End Sub

            Friend Sub GetPositions(ByRef nPos As Integer, ByRef nPosEnd As Integer)
                Dim nPosEndTemp As Integer


                Dim nobjRawPos As Integer
                Dim nobjLength As Integer

                If mnRawPos >= 0 And mnRawPosEnd >= 0 Then
                    nPos = mnRawPos
                    nPosEnd = mnRawPosEnd
                    Exit Sub
                End If

                nPos = System.Int32.MaxValue
                nPosEnd = -1

                For Each objKogame As clsKoGame In Me.KoGames
                    If objKogame.IsClsRawData Then
                        With objKogame.ToClsRawData
                            nobjRawPos = .Pos
                            nobjLength = .Length
                        End With
                    ElseIf objKogame.IsClsReffer Then
                        With objKogame.ToClsReffer
                            nobjRawPos = .FromOffset
                            nobjLength = .Length
                        End With
                    ElseIf objKogame.IsClsCash Then
                        With objKogame.ToClsCash
                            nobjRawPos = .RawOffset
                            nobjLength = .Length
                        End With
                    End If
                    nPosEndTemp = nobjRawPos + nobjLength - 1

                    nPos = System.Math.Min(nPos, nobjRawPos)
                    nPosEnd = System.Math.Max(nPosEnd, nPosEndTemp)

                    mnRawPos = nPos
                    mnRawPosEnd = nPosEnd
                Next

            End Sub

            Friend ReadOnly Property CanCashIn(ByVal objCash As clsCashed) As Integer
                Get

                    If objCash.RawOffset < mnRawPos Then
                        Return False
                    End If
                    If objCash.RawOffset > mnRawPosEnd Then
                        Return False
                    End If

                    If objCash.Length + objCash.RawOffset - 1 > mnRawPosEnd Then
                        Return False
                    End If

                    Return True
                End Get
            End Property

            Friend Function GetLiveKoGameCnt() As Integer
                Dim nCnt As Integer
                nCnt = 0
                For Each objKoGame As clsKoGame In Me.KoGames
                    If objKoGame.Disabled = False Then
                        nCnt += 1
                    End If
                Next
                Return nCnt
            End Function


            Friend Sub CreateTempClone_GetRawPoses(ByRef nRawPos As Integer, ByRef nRawPosEnd As Integer)
                nRawPos = Me.mnRawPos
                nRawPosEnd = Me.mnRawPosEnd
            End Sub

            Friend Sub CreateTempClone_SetRawPoses(ByVal nRawPos As Integer, ByVal nRawPosEnd As Integer)
                Me.mnRawPos = nRawPos
                Me.mnRawPosEnd = nRawPosEnd
            End Sub

        End Class


        Friend Class clsBlockChains


            Friend Enum FRAMETYPE
                RAWDATA = 0
                CASH
                REFFER
            End Enum


            'Private mBlockChainInCls As System.Collections.Generic.List(Of clsOyaGame)
            Private mBlockChainInCls As System.Collections.Generic.List(Of clsFrame)

            Friend mobjArrayHash As clsArrayHash(Of clsByteKey, Integer)
            Friend mCashImageManager As clsCashImageManager

            Friend PreUnzipData() As System.Byte


            Friend Sub New()
                'Me.mBlockChainInCls = New System.Collections.Generic.List(Of clsOyaGame)(1)
                Me.mBlockChainInCls = New System.Collections.Generic.List(Of clsFrame)(1)
            End Sub


            Default Friend ReadOnly Property Item(ByVal nOyagameNo As Integer) As clsFrame
                Get
                    Return Me.mBlockChainInCls(nOyagameNo)
                End Get
            End Property

            Friend ReadOnly Property ItemLast() As clsFrame
                Get
                    Dim nNo As Integer
                    nNo = Me.mBlockChainInCls.Count - 1
                    Return Me.mBlockChainInCls(nNo)
                End Get
            End Property


            Friend Function GetFrameFromRawPos(ByVal nUnzipPos) As clsFrame

                Dim nIndex As Integer
                ' 'nIndex = mList.BinarySearch(lSearch, AddressOf lSearch(0).CompareToCashOffet_list)

                nIndex = Me.mBlockChainInCls.BinarySearch(lSearch, mBlockChainInCls(0).CompareTo)

                If nIndex < 0 Then
                    ' 通常はこういう事ないけれど…。
                    nIndex = -nIndex
                Else
                    nIndex += 1
                    If nIndex >= Me.mList.Count Then
                        Return -1
                    End If
                End If
            End Function

            Friend Sub SplitCurrentFrameAndToReffer(ByVal nUnzipPos As Integer, _
                ByVal nMatchLength As Integer, ByVal nResPos As Integer)

            End Sub

            ''' <summary>
            ''' 
            ''' </summary>
            ''' <param name="objCutFrame"></param>
            ''' <param name="nUnzipPos"></param>
            ''' <param name="nMatchLength"></param>
            ''' <param name="nResPos"></param>
            ''' <remarks>
            ''' 　　一応、どこからでも呼べる「汎用のRawToReffer」として作っておく。
            ''' </remarks>
            Friend Sub ChangeFrame_RawToReffer(ByVal objCutFrame As clsFrame, _
                             ByVal nUnzipPos As Integer, _
                             ByVal nMatchLength As Integer, ByVal nResPos As Integer)

                If objCutFrame.IsRawData = False Then
                    clsDelfGen.ErrMsg("プログラムエラー！" & vbCrLf & "RawDataでないのにRawDataとして扱おうとした！", _
                            New System.Diagnostics.StackFrame())
                    Exit Sub
                End If

                If objCutFrame.RawOffSet > nUnzipPos Or objCutFrame.RawOffsetEnd < nUnzipPos Then
                    clsDelfGen.ErrMsg("プログラムエラー！" & vbCrLf & "分割するRawイチ指定がおかしい", _
                            New System.Diagnostics.StackFrame())
                    Exit Sub
                End If

                ' (RawData)  (reffer) (RawData) に分割する
                
                objCutFrame.Length = nUnzipPos - objCutFrame.RawOffSet
                Dim objReffer As clsFrame
                Dim objCash As clsFrame

                objReffer = Me.SplitFrame(objFrame:=objCutFrame, _
                                          nUnzipPos:=nUnzipPos, nMatchLength:=nMatchLength, _
                                            nAddedFrameType:=FRAMETYPE.RAWDATA)


            End Sub


            ''' <summary>
            ''' Cash,Reffer 挿入用にフレーム clsFrame を追加する
            ''' 　追加先が RawData の場合：
            ''' 
            '''   追加先がCashフレームの場合：
            ''' 　　　　Cashフレームを重ね置きして連続キャッシュ扱いにする
            ''' 　　　　　　(キャッシュの生存期間が完全に異なる場合は
            ''' 　　　　　　　別途検討
            ''' 　
            '''   追加先がRefferフレームの場合：
            ''' </summary>
            ''' <param name="objFrame"></param>
            ''' <param name="nUnzipPos"></param>
            ''' <param name="nMatchLength"></param>
            ''' <returns></returns>
            ''' <remarks></remarks>
            Friend Function SplitFrame(ByVal objFrame As clsFrame, _
                             ByVal nUnzipPos As Integer, _
                             ByVal nMatchLength As Integer, ByVal nAddedFrameType As clsBlockChains.FRAMETYPE) As clsFrame

                ' 0 1 2 3 4 5
                '       3 4 5

                If objFrame.IsRawData Then



                    Return Me.SplitRawDataFrame(objFrame, nUnzipPos, nMatchLength, nAddedFrameType)
                End If
            End Function


            ''' <summary>
            ''' 
            ''' </summary>
            ''' <param name="objFrame"></param>
            ''' <param name="nUnzipPos"></param>
            ''' <param name="nMatchLength"></param>
            ''' <returns>新たに使用可能なフレーム</returns>
            ''' <remarks></remarks>
            Friend Function SplitRawDataFrame(ByVal objFrame As clsFrame, _
                             ByVal nUnzipPos As Integer, _
                             ByVal nMatchLength As Integer, _
                             ByVal nAddedFrameType As clsBlockChains.FRAMETYPE) As clsFrame


                If objFrame.RawOffSet = nUnzipPos Then
                    If objFrame.Length = nMatchLength Then
                        ' そのまま流用
                        Return objFrame
                    ElseIf objFrame.Length > nMatchLength Then

                        ' 開始地点が同じだったら、余った後半部分は
                        ' RawDataFrame 扱いにする。

                        Dim objNewFrame As New clsFrame
                        With objNewFrame
                            .Length = nUnzipPos + nMatchLength - .RawOffSet
                            .RawOffSet = nUnzipPos + nMatchLength

                            .Previous = objFrame
                            .Next = objFrame.Next

                            objFrame.Next = objNewFrame

                            If .Next IsNot Nothing Then
                                .Next.Previous = objNewFrame
                            End If
                        End With
                        Me.mBlockChainInCls.Insert( _
                                Me.mBlockChainInCls.IndexOf(objFrame) + 1, _
                                objNewFrame)

                        With objFrame
                            .RawOffSet = nUnzipPos
                            .Length = nMatchLength
                        End With

                        Return objFrame


                    Else
                        ' objFrame を飛び出た分は・・・・
                        ' どうするんだろうｗ
                        ' reffer 挿入フェーズでは多分いらない筈なんだけど

                        '右となりがcash、refferだったら飛び出たまんま？
                        ' 挿入するオブジェクトによるだろう。

                        ' とりあえず飛び出たままにする。
                        With objFrame
                            Dim nOldLength As Integer
                            nOldLength = .Length
                            .Length = nMatchLength
                        End With
                    End If



                End If

                ' フレームが入りきる場合
                If objFrame.RawOffsetEnd >= nUnzipPos + nMatchLength Then
                    ' (RawData)  (reffer) (RawData) に分割する
                    Dim nOldRawoffsetEnd As Integer

                    nOldRawoffsetEnd = objFrame.RawOffsetEnd
                    objFrame.Length = nUnzipPos - objFrame.RawOffSet


                    Dim objNewFrame As New clsFrame

                    With objNewFrame
                        .RawOffSet = nUnzipPos
                        .Length = nMatchLength

                        .SetPreNext(objFrame, objFrame.Next)

                        Me.mBlockChainInCls.Insert( _
                                Me.mBlockChainInCls.IndexOf(objFrame) + 1, _
                                objNewFrame)
                    End With

                    ' ケツのRawData のサイズが０でないなら
                    If nOldRawoffsetEnd - objNewFrame.RawOffsetEnd > 0 Then
                        Dim objTailFrame As New clsFrame
                        With objTailFrame
                            .RawOffSet = objNewFrame.RawOffsetEnd
                            .Length = nOldRawoffsetEnd - objNewFrame.RawOffsetEnd

                            .SetPreNext(objNewFrame, objNewFrame.Next)

                            Me.mBlockChainInCls.Insert( _
                                    Me.mBlockChainInCls.IndexOf(objNewFrame) + 1, _
                                    objTailFrame)
                        End With



                        Return objNewFrame
                    End If
                End If


                ' 指定のフレームに入りきらない場合
                ' RawData に入りきらない・・・＞
                ' 　　後ろがCash/Refferになる。
                '     Refferだったらその前にキャッシュを入れる感じになる？


                objFrame.Length = nUnzipPos - objFrame.RawOffSet

                If objFrame.Next Is Nothing Then
                    clsDelfGen.ErrMsg("プログラムエラー！" & vbCrLf & _
                                "末端のフレームに、それを超える長さのフレームを入れようとした。", _
                                New System.Diagnostics.StackFrame())

                End If


                Dim objNewFrame2 As New clsFrame
                With objNewFrame2
                    ' とりあえず長さとかは入れとく。
                    .RawOffSet = nUnzipPos
                    .Length = nMatchLength
                End With

                If objFrame.Next.IsRawData Then
                    ' rawdata > rawdata と続く事は
                    '　今のとこの設計案では通常はないはず。
                End If


                ' 追加先の、次のフレームががrefferだったらその前に入れる。
                ' キャッシュを追加するんだったら前後関係が重要


                ' cash > reffer だったら一つの集合フレーム扱いに
                ' しちゃっていいのかな？

                ' よく分からんけど、追加するフレーム種別を関数の引数で渡しておこうｗ


                If objFrame.Next.IsCash Then

                    'If nAddedFrameType = FRAMETYPE.CASH Then


                    '    ↓ Cash
                    ' (Raw) (Cash)
                    '  　キャッシュのマルチキャッシュフレームに。

                    objNewFrame2.SetPreNext(objFrame, objFrame.Next)

                    Me.mBlockChainInCls.Insert( _
                            Me.mBlockChainInCls.IndexOf(objFrame) + 1, _
                            objNewFrame2)
                    Call objNewFrame2.SetMeOnMutiCashessTop()

                    Return objNewFrame2

                    'ElseIf nAddedFrameType = FRAMETYPE.REFFER Then
                    '    ↓ reffer
                    ' (Raw) (cash)
                    ' この場合、キャッシュがReffer の前まで長く拡張される。
                    ' ・・・が、キャッシュ化されたエリアにRefferを入れるという
                    ' のはロジックの順番上有り得ないので何もしない事にする。

                    'End If

                ElseIf objFrame.Next.IsReffer Then

                    ' reffer にかぶるように reffer を入れる事は通常有り得ない？
                    ' せいぜいキャッシュを無理やり押し込むぐらいだよな？

                    'If nAddedFrameType = FRAMETYPE.CASH Then

                    ' よく分からんけど、そのまま Refferの前にキャッシュ入れとくか・・・。

                    objNewFrame2.SetPreNext(objFrame, objFrame.Next)

                    Me.mBlockChainInCls.Insert( _
                            Me.mBlockChainInCls.IndexOf(objFrame) + 1, _
                            objNewFrame2)

                    Return objNewFrame2



                    'End If
                End If

                clsDelfGen.ErrMsg("プログラムエラー！" & vbCrLf & _
                            "想定外。RawDataフレームを分割してRawDataフレームを末尾に入れようとした。", _
                            New System.Diagnostics.StackFrame())

                Return Nothing

            End Function


#If 0 Then
            ' Raw 前提の列を、一致したトコだけ参照フレーム変更する。
            ' 多分 SpiritemBlockChainByReffer からしか呼ばれない。
            Friend Sub SplitCurrentFrameAndToReffer(ByVal nUnzipPos As Integer, _
                ByVal nMatchLength As Integer, ByVal nResPos As Integer)



                Dim objRawData As clsRawData
                Dim nLastRawDataLength As Integer
                objRawData = Me.mBlockChainInCls(mCurrentOyagame).KoGames(0).ToClsRawData
                ' 直近のRawデータ長を変更
                nLastRawDataLength = objRawData.Length - (nMatchLength) - (nUnzipPos - objRawData.Pos)
                objRawData.Length = nUnzipPos - objRawData.Pos
                If objRawData.Length = 0 Then
                    ' Rawの残り全部、データ最後まで参照に出来るのなら
                    ' 直近のRawDataを参照フレームに変更
                    Me.mBlockChainInCls(mCurrentOyagame).KoGames.RemoveAt(0)

                    Dim objRef As clsReffer
                    objRef = New clsReffer()
                    objRef.Length = nMatchLength
                    objRef.ToOffset = nResPos
                    objRef.FromOffset = nUnzipPos
                    objRef.Parent = Me.mBlockChainInCls(mCurrentOyagame)
                    Me.mBlockChainInCls(mCurrentOyagame).KoGames.Add(objRef)

                    'mCurrentOyagame += 1
                Else

                    Dim objRef As clsReffer
                    objRef = New clsReffer()
                    objRef.Length = nMatchLength
                    objRef.ToOffset = nResPos
                    objRef.FromOffset = nUnzipPos
                    'objRef.Parent = objOyagameNew
                    'objOyagameNew.KoGames.Add(objRef)


                    ' 直前が参照フレームだったらそこに足す
                    If Me.mBlockChainInCls(mCurrentOyagame).Previous IsNot Nothing Then
                        Dim objPreOyagame As clsOyaGame _
                                = Me.mBlockChainInCls(mCurrentOyagame).Previous
                        If objPreOyagame.IsClsRawData = False Then

                            objRef.Parent = objPreOyagame
                            objPreOyagame.KoGames.Add(objRef)

                            Exit Sub
                        End If
                    End If

                    Dim objOyagameRef As clsOyaGame
                    objOyagameRef = New clsOyaGame()
                    Me.mBlockChainInCls.Add(objOyagameRef)
                    If Me.mBlockChainInCls.Count > 0 Then
                        Me.mBlockChainInCls(mCurrentOyagame).Next = objOyagameRef
                        objOyagameRef.Previous = Me.mBlockChainInCls(mCurrentOyagame)
                    End If


                    objRef.Parent = objOyagameRef
                    objOyagameRef.KoGames.Add(objRef)


                    ' 最後にrawフレーム足す

                    objRawData = New clsRawData()
                    objRawData.Pos = nUnzipPos + nMatchLength
                    objRawData.Length = nLastRawDataLength

                    Dim objOyagameNew As clsOyaGame
                    objOyagameNew = New clsOyaGame()
                    Me.mBlockChainInCls.Add(objOyagameNew)
                    objOyagameRef.Next = objOyagameNew
                    objOyagameNew.Previous = objOyagameRef

                    objRawData.Parent = objOyagameNew
                    objOyagameNew.KoGames.Add(objRawData)

                End If

            End Sub
#End If





            ''' <summary>
            ''' 
            ''' </summary>
            ''' <param name="objOyagame"></param>
            ''' <param name="nRawPos">objOyagameに新たに挿入される小亀のRawPos</param>
            ''' <param name="nLength"></param>
            ''' <param name="objBlockChains"></param>
            ''' <returns></returns>
            ''' <remarks></remarks>
            Friend Shared Function CutOyagameRawDataSize_Top(ByVal objOyagame As clsOyaGame, ByVal nRawPos As Integer, ByVal nLength As Integer, ByVal objBlockChains As clsBlockChains) As clsOyaGame

                If objOyagame.Previous Is Nothing Then
                    ' 何もしないでいいような・・・。
                    ' よく分からん。
                    Return objOyagame
                End If
                If objOyagame.Previous.IsClsRawData Then
                    With objOyagame.Previous.ToClsRawData

                        If nRawPos - .Pos > 0 Then
                            .Length = nRawPos - .Pos
                        Else
                            ' マージ
                            Dim objMergeOyaGame As clsOyaGame
                            objMergeOyaGame = objOyagame.Previous.Previous

                            If objMergeOyaGame Is Nothing Then
                                ' 先頭へ
                                objOyagame.Previous = Nothing
                                objBlockChains.OyaGames.Remove(objOyagame.Previous)
                            Else

                                If objMergeOyaGame.IsClsRawData Then
                                    ' 理屈上はRawData の次にRawDataが続く事は無いんだけど・・・。
                                    objMergeOyaGame.Next = objOyagame
                                    objOyagame.Previous = objMergeOyaGame
                                    objBlockChains.OyaGames.Remove(objOyagame.Previous)
                                Else
                                    ' objOyagame.Previous を削除して連結
                                    objBlockChains.OyaGames.Remove(objOyagame.Previous)
                                    objMergeOyaGame.Next = objOyagame
                                    objOyagame.Previous = objMergeOyaGame


                                    objBlockChains.MergeNextOyagame(objMergeOyaGame)

                                End If
                                '使わないが、前のを返す
                                Return objOyagame.Previous
                            End If
                        End If


                    End With
                    objOyagame.DropLength()
                    Return objOyagame.Previous
                End If

                ' 混在フレームなので RawData を追加
                ' 親亀挿入処理
                Dim objNewOyagame As clsOyaGame
                objNewOyagame = New clsOyaGame()
                clsBlockChains.InsertNewOyaGame(objOyagame, objNewOyagame, objBlockChains)
                Dim objRawData As New clsRawData
                objRawData.Pos = nRawPos - nLength
                objRawData.Length = nLength
                objRawData.Parent = objNewOyagame
                objNewOyagame.KoGames.Add(objRawData)

                Return objNewOyagame
            End Function



            Friend Shared Function CutOyagameRawDataSize_End(ByVal objOyagame As clsOyaGame, ByVal nRawPos As Integer, ByVal nLength As Integer, _
                                                                  ByVal objBlockChains As clsBlockChains) As clsOyaGame
                If objOyagame.Next Is Nothing Then
                    ' 何もしないでいいような・・・。
                    ' よく分からん。
                    Return objOyagame
                End If
                If objOyagame.Next.IsClsRawData Then
                    With objOyagame.ToClsRawData


                        If .Length = nRawPos - .Pos Then
                            ' マージ
                            Dim objMergeOyaGame As clsOyaGame
                            objMergeOyaGame = objOyagame.Next.Next

                            If objMergeOyaGame Is Nothing Then
                                ' 先頭へ
                                objOyagame.Next = Nothing
                                objBlockChains.OyaGames.Remove(objOyagame.Next)
                            Else

                                If objMergeOyaGame.IsClsRawData Then
                                    ' 理屈上はRawData の次にRawDataが続く事は無いんだけど・・・。
                                    objMergeOyaGame.Previous = objOyagame
                                    objOyagame.Next = objMergeOyaGame
                                    objBlockChains.OyaGames.Remove(objOyagame.Next)
                                Else
                                    ' objOyagame.Next を削除して連結
                                    objBlockChains.OyaGames.Remove(objOyagame.Next)
                                    objMergeOyaGame.Previous = objOyagame
                                    objOyagame.Next = objMergeOyaGame


                                    objBlockChains.MergeNextOyagame(objOyagame)

                                End If
                                '使わないが、次のを返す

                                Return objOyagame.Next
                            End If
                        Else
                            .Length -= nRawPos - .Pos
                            .Pos = nRawPos
                        End If


                    End With
                    objOyagame.DropLength()
                    Return objOyagame.Next
                End If


                ' 混在フレームなので RawData を追加
                ' 親亀挿入処理
                Dim objNewOyagame As clsOyaGame
                objNewOyagame = New clsOyaGame()
                clsBlockChains.InsertNewOyaGame(objOyagame.Next, objNewOyagame, objBlockChains)
                Dim objRawData As New clsRawData
                objRawData.Pos = nRawPos - nLength
                objRawData.Length = nLength
                objRawData.Parent = objNewOyagame
                objNewOyagame.KoGames.Add(objRawData)

                Return objNewOyagame
            End Function


            Friend Sub MergeNextOyagame(ByVal objOyaGame As clsOyaGame)

                For Each objKoGame As clsKoGame In objOyaGame.Next.KoGames

                    objKoGame.Parent = objOyaGame
                    objOyaGame.KoGames.Add(objKoGame)
                Next

                Dim objDeleteOyagame As clsOyaGame

                With objOyaGame.Next.KoGames
                    For nCnt As Integer = 0 To .Count - 1
                        .RemoveAt(0)
                    Next

                    objDeleteOyagame = objOyaGame.Next
                    objOyaGame.Next = objOyaGame.Next.Next
                    objOyaGame.Next.Next.Previous = objOyaGame

                End With
                Me.mBlockChainInCls.Remove(objDeleteOyagame)
                objOyaGame.DropLength()

            End Sub

            Friend Shared Sub InsertNewOyaGame(ByVal objOyamgameInsertPos As clsOyaGame, ByVal objOyaGame As clsOyaGame, ByVal objBlockChains As clsBlockChains)
                Dim nPos As Integer

                nPos = objBlockChains.OyaGames.IndexOf(objOyamgameInsertPos)
                clsBlockChains.InsertNewOyaGame(nPos, objOyaGame, objBlockChains)
            End Sub


            Friend Shared Sub InsertNewOyaGame(ByVal nOyamgameNo As Integer, ByVal objOyaGame As clsOyaGame, ByVal objBlockChains As clsBlockChains)

                objBlockChains.OyaGames.Insert(nOyamgameNo, objOyaGame)

                objOyaGame.Previous = objBlockChains(nOyamgameNo)
                objOyaGame.Next = objBlockChains(nOyamgameNo).Next

                objBlockChains(nOyamgameNo).Next = objOyaGame
                objBlockChains(nOyamgameNo).Next.Previous = objOyaGame

            End Sub


            Friend Sub AddNewOyaGameLast(ByVal objOyaGame As clsOyaGame)


                mBlockChainInCls.Add(objOyaGame)
                Dim nLastOyagame As Integer

                nLastOyagame = mBlockChainInCls.Count - 1
                If nLastOyagame = 0 Then
                    objOyaGame.Previous = Nothing
                Else
                    objOyaGame.Previous = mBlockChainInCls(nLastOyagame)
                End If

                objOyaGame.Next = Nothing

                mBlockChainInCls(nLastOyagame).Next = objOyaGame

            End Sub




            Friend Shared Sub DisableCash(ByVal objDeleteCash As clsCashed, ByVal nReason As clsKoGame.DisabledReasons, ByVal objBlockChains As clsBlockChains)


                For Each objRef As clsReffer In objDeleteCash.Reffereds

                    objRef.Disabled = True
                    objRef.DisabledReason = nReason


                    If objRef.Parent.GetLiveKoGameCnt = 0 Then

                        Call clsBlockChains.DisableCash_DsiableCashAndToRawData( _
                                             objRef, objBlockChains)

                    Else

                        ' キャッシュ(保存命令に相当)が入ってるはず
                        ' Reffer と長さは当然異なって当たり前なので、
                        ' Reffer と キャッシュの被らなかった部分を
                        ' RawData に置きなおす必要がある。





                        ' 一つの混在フレームに複数のキャッシュが入る事がある。
                        ' (キャッシュA) 位置的に連続してその後に(キャッシュB)
                        '　えっと・・・・
                        ' 普通ならA,Bは MergeCashesOnOneOyagame で一つのキャッシュにまとめられる
                        ' はず？
                        ' なんで「混在フレーム」に複数のキャッシュが入るんだっけ？
                        ' 忘れたｗ
                        ' 連結キャッシュどうたらあった気がするが忘れたわｗ
                        ' 忘れてるから別にいいか・・・。

                        ' 重ねキャッシュ対策が出来てないしｗ


                        ' 有効キャッシュを取得
                        Dim objCash As clsCashed
                        objCash = Nothing
                        For Each objKogame As clsKoGame In objRef.Parent.KoGames
                            If objKogame.Disabled = True Then
                                Continue For
                            End If

                            If objKogame.IsClsCash = True Then
                                ' たぶんキャッシュは一つしかないはず
                                objCash = objKogame.ToClsCash
                                Exit For
                            End If

                        Next
                        If objCash Is Nothing Then
                            ' キャッシュ無かったら…。どうしよｗ
                            ' テキトーに RawData でも足しとくか…。

                            Dim objRawData As New clsRawData()

                            Console.WriteLine("clsCashImage::DisableReffer Warning!: プログラムエラー。 キャッシュが入ってるはずなのにないよ。")

                            objRawData.Pos = objRef.FromOffset
                            objRawData.Length = objRef.Length
                            objRawData.Parent = objRef.Parent
                            objRef.Parent.KoGames.Insert(0, objRawData)

                            Continue For
                        End If

                        ' Cash が Disable になった分を RawData に変更する
                        ' ついでに前後が clsRawData だったらそちらに合体する
                        Call clsBlockChains.DisableCash_DsiableCashAndToOneRefferOrOneCash( _
                           objCash, objRef, objBlockChains)
                    End If



                Next


                objDeleteCash.Disabled = True
                objDeleteCash.DisabledReason = nReason

                ' 同じ子亀は何あるかな？
                ' Refferぐらいしかないはず？？？
                Dim nKogameCnt As Integer
                Dim bRefferFind As Boolean
                nKogameCnt = 0
                bRefferFind = False
                Do While nKogameCnt < objDeleteCash.Parent.KoGames.Count

                    If objDeleteCash.Parent.KoGames(nKogameCnt).Disabled = True Then
                        nKogameCnt += 1
                        Continue Do
                    End If

                    If objDeleteCash.Parent.KoGames(nKogameCnt).IsClsReffer = False Then
                        nKogameCnt += 1
                        Continue Do
                    End If

                    bRefferFind = True

                    ' たぶん共用化できるはず？
                    Call clsBlockChains.DisableCash_DsiableCashAndToOneRefferOrOneCash( _
                                    objDeleteCash, objDeleteCash.Parent.KoGames(nKogameCnt), objBlockChains)

                    ' たぶん Reffer が一つあるだけのはずなんだけど…。
                    Exit Do


                    'nKogameCnt += 1
                Loop

                If bRefferFind = False Then
                    ' 混在フレームではないので削除したCashに相当する RawData を足す。


                    Call clsBlockChains.DisableCash_DsiableCashAndToRawData( _
                                         objDeleteCash, objBlockChains)


                End If

            End Sub

            ' 参照するフレームを RawData 化
            ' 参照「される」キャッシュを RawData 化
            Private Shared Sub DisableCash_DsiableCashAndToOneRefferOrOneCash(ByVal objCash As clsCashed, ByVal objNewKoGameSize As clsKoGame, ByVal objBlockChains As clsBlockChains)


                Dim nNewOyagamePos As Integer
                Dim nNewOyagameLength As Integer


                If objNewKoGameSize.IsClsCash Then
                    nNewOyagamePos = objNewKoGameSize.ToClsCash.RawOffset
                ElseIf objNewKoGameSize.IsClsReffer Then
                    nNewOyagamePos = objNewKoGameSize.ToClsReffer.FromOffset
                End If

                nNewOyagameLength = objNewKoGameSize.Length

                ' reffer の頭が飛び出る場合
                If objCash.RawOffset > nNewOyagamePos Then

                    If objNewKoGameSize.Parent.Previous Is Nothing Then








                        ' 前が Nothing の場合が考慮されていない！！！








                    End If


                    ' 頭に clsRawData を足す
                    If objNewKoGameSize.Parent.Previous.IsClsRawData Then
                        objNewKoGameSize.Parent.Previous.ToClsRawData.Length += nNewOyagamePos - objCash.RawOffset
                    Else
                        Dim objRawData As New clsRawData()

                        Dim objNewOyagame As New clsOyaGame()
                        objRawData.Pos = nNewOyagamePos
                        objRawData.Length = nNewOyagamePos - objCash.RawOffset
                        objRawData.Parent = objNewOyagame
                        objNewOyagame.KoGames.Add(objRawData)

                        ' ・・・ここで mBlockChains を本当は参照出来るはずなんだけど、
                        ' なんか出来ない気がするｗ
                        ' Private じゃなく Friend か Protect なら読めていいはずなんだけど
                        ' なんか VB.Net だと読めないんだよな。
                        clsBlockChains.InsertNewOyaGame(objRawData.Parent, objNewOyagame, objBlockChains)

                    End If

                End If

                ' reffer のけつが飛び出る場合
                If objCash.RawOffset + objCash.Length < nNewOyagamePos + nNewOyagameLength Then

                    If objCash.Parent.Next Is Nothing Then
                        Dim objRawData As New clsRawData()

                        Dim objNewOyagame As New clsOyaGame()
                        objRawData.Pos = objCash.RawOffset + objCash.Length
                        objRawData.Length = nNewOyagamePos + nNewOyagameLength - (objCash.RawOffset + objCash.Length)
                        objRawData.Parent = objNewOyagame
                        objNewOyagame.KoGames.Add(objRawData)

                        objBlockChains.AddNewOyaGameLast(objNewOyagame)

                    ElseIf objCash.Parent.Next.IsClsRawData Then

                        With objCash.Parent.Next.ToClsRawData
                            .Pos -= nNewOyagamePos + nNewOyagameLength - (objCash.RawOffset + objCash.Length)
                            .Length += nNewOyagamePos + nNewOyagameLength - (objCash.RawOffset + objCash.Length)
                        End With

                    Else

                        Dim objRawData As New clsRawData()

                        Dim objNewOyagame As New clsOyaGame()
                        objRawData.Pos = objCash.RawOffset + objCash.Length
                        objRawData.Length = nNewOyagamePos + nNewOyagameLength - (objCash.RawOffset + objCash.Length)
                        objRawData.Parent = objNewOyagame
                        objNewOyagame.KoGames.Add(objRawData)

                        objBlockChains.AddNewOyaGameLast(objNewOyagame)

                    End If
                End If

            End Sub




            ''' <summary>
            '''   汎用性の高いコガメ追加関数を作ってみる
            ''' 　とりあえず DisableCash, CreateCashFrameOnBlockChains の処理を「分かり易く」
            ''' 　共通化する。
            ''' </summary>
            ''' <param name="objOyagamePos"></param>
            ''' <param name="objKogame"></param>
            ''' <param name="objBlockChains"></param>
            ''' <remarks></remarks>
            Private Shared Sub AddFrame(ByVal objOyagamePos As clsOyaGame, ByVal objKogame As clsKoGame, _
                                            ByVal objBlockChains As clsBlockChains)

            End Sub


            Private Shared Sub DisableCash_DsiableCashAndToRawData( _
                  ByVal objKoGame As clsKoGame, _
                  ByVal objBlockChains As clsBlockChains)


                ' 一つ前の親フレームが RawData だったら合体する。
                If objKoGame.Parent.Previous IsNot Nothing Then
                    If objKoGame.Parent.Previous.IsClsRawData = True Then


                        ' (RawData) (削除するKogame) 
                        ' → (RawData)
                        Dim objNewOyaGame As clsOyaGame

                        objKoGame.Parent.Previous.ToClsRawData.Length += objKoGame.Length

                        objNewOyaGame = objKoGame.Parent.Previous
                        objBlockChains.MergeNextOyagame(objNewOyaGame)

                        ' 次が混在フレームでなく RawData だったら合体する
                        If objNewOyaGame.Next IsNot Nothing Then
                            If objNewOyaGame.Next.IsClsRawData Then

                                ' (RawData) (削除するKogame) (RawData)
                                ' (RawData)

                                ' ・・・多分長さをいじるだけで平気なはずなんだけど・・・。
                                objNewOyaGame.ToClsRawData.Length += _
                                 objNewOyaGame.Next.ToClsRawData.Length
                                objNewOyaGame.Next.KoGames.RemoveAt(0)
                                objBlockChains.MergeNextOyagame(objNewOyaGame)

                            End If

                        End If


                    Else


                        ' 削除する親亀の次がRawDataだったら合体する
                        If objKoGame.Parent.Next.IsClsRawData = True Then

                            ' (混在フレーム) (削除するKogame) (RawData)
                            ' → (混在フレーム)(RawData)

                            Dim objDeleteOyagame As clsOyaGame
                            Dim objNewOyaGame As clsOyaGame

                            objKoGame.Parent.Next.ToClsRawData.Length += objKoGame.Length


                            objDeleteOyagame = objKoGame.Parent
                            objNewOyaGame = objKoGame.Parent.Next

                            objDeleteOyagame.Previous.Next = objDeleteOyagame.Next
                            objDeleteOyagame.Next.Previous = objDeleteOyagame.Previous
                            objDeleteOyagame.KoGames.RemoveAt(0)
                            objBlockChains.OyaGames.Remove(objDeleteOyagame)

                            ' べっつに削除した小亀なんか使う事ないと思うけど・・・。
                            ' まぁ念のため残しておく。
                            objKoGame.Parent = objNewOyaGame
                            objNewOyaGame.KoGames.Add(objKoGame)
                        Else

                            ' (混在フレーム) (削除するKogame) (混在フレーム)
                            ' → (混在フレーム)(RawData) (混在フレーム)

                            ' キャッシュか参照ブロック？
                            Dim objRawData As New clsRawData()

                            If objKoGame.IsClsCash Then
                                Dim objCash As clsCashed = objKoGame.ToClsCash
                                objRawData.Pos = objCash.RawOffset
                                objRawData.Length = objCash.Length
                            ElseIf objKoGame.IsClsReffer Then
                                Dim objReffer As clsReffer = objKoGame.ToClsReffer
                                objRawData.Pos = objReffer.FromOffset
                                objRawData.Length = objReffer.Length

                            End If
                            objRawData.Parent = objKoGame.Parent

                            objKoGame.Parent.KoGames.Insert(0, objRawData)



                        End If


                    End If


                Else

                    ' 先頭:(削除するKoGameフレーム)

                    If objKoGame.Parent.Next IsNot Nothing Then
                        If objKoGame.Parent.Next.IsClsRawData Then

                            ' 先頭:(削除するKoGameフレーム) (RawData)
                            ' → 先頭:(RawData)

                            Dim ObjDeleteOyagame As clsOyaGame = objKoGame.Parent
                            Dim objNewOyaGame As clsOyaGame = objKoGame.Parent.Next

                            objNewOyaGame.ToClsRawData.Length += objKoGame.Length
                            objNewOyaGame.Previous = Nothing

                            ObjDeleteOyagame.KoGames.Remove(objKoGame)
                            objBlockChains.OyaGames.Remove(ObjDeleteOyagame)

                            ' べっつに削除した小亀なんか使う事ないと思うけど・・・。
                            ' まぁ念のため残しておく。
                            objKoGame.Parent = objNewOyaGame
                            objNewOyaGame.KoGames.Add(objKoGame)
                        Else

                            ' 先頭:(削除するKoGameフレーム) (混在フレーム)
                            ' → 先頭:(RawData) (混在フレーム)
                            ' キャッシュか参照ブロック？
                            Dim objRawData As New clsRawData()

                            If objKoGame.IsClsCash Then
                                Dim objCash As clsCashed = objKoGame.ToClsCash
                                objRawData.Pos = objCash.RawOffset
                                objRawData.Length = objCash.Length
                            ElseIf objKoGame.IsClsReffer Then
                                Dim objReffer As clsReffer = objKoGame.ToClsReffer
                                objRawData.Pos = objReffer.FromOffset
                                objRawData.Length = objReffer.Length

                            End If
                            objRawData.Parent = objKoGame.Parent

                            objKoGame.Parent.KoGames.Insert(0, objRawData)


                        End If
                    Else


                        ' 先頭:(削除するKoGameフレーム) (混在フレーム)
                        ' → 先頭:(RawData) (混在フレーム)
                        ' キャッシュか参照ブロック？
                        Dim objRawData As New clsRawData()

                        If objKoGame.IsClsCash Then
                            Dim objCash As clsCashed = objKoGame.ToClsCash
                            objRawData.Pos = objCash.RawOffset
                            objRawData.Length = objCash.Length
                        ElseIf objKoGame.IsClsReffer Then
                            Dim objReffer As clsReffer = objKoGame.ToClsReffer
                            objRawData.Pos = objReffer.FromOffset
                            objRawData.Length = objReffer.Length
                        End If
                        objRawData.Parent = objKoGame.Parent

                        objKoGame.Parent.KoGames.Insert(0, objRawData)





                    End If


                End If

            End Sub


            ' キャッシュの試行錯誤用にコピー親亀チェーンを作る
            Friend Function CreateTempClone() As clsBlockChains

                Dim objOyaGames As clsBlockChains
                Dim objNewOyagames As New clsBlockChains()

                objOyaGames = Me

                With objNewOyagames
                    .mCurrentOyagame = objOyaGames.CreateTempClone_GetCurKameNo()
                    .mobjArrayHash = objOyaGames.mobjArrayHash

                    ' キャッシュイメージは後でコピーいるよね。
                    ' .mCashImageManager = objOyaGames.mCashImageManager
                    .PreUnzipData = objOyaGames.PreUnzipData
                End With

                objNewOyagames.OyaGames = New System.Collections.Generic.List(Of clsOyaGame)( _
                   objOyaGames.OyaGames.Count)


                For nOyagame As Integer = 0 To objOyaGames.OyaGames.Count - 1

                    Dim objNewOyaGame As New clsOyaGame()
                    Dim nRawPos As Integer
                    Dim nRawPosEnd As Integer
                    objNewOyagames.OyaGames(nOyagame) = objNewOyaGame

                    ' プライベート宣言変数のコピーでこんな苦労するのかよ・・・・。
                    objOyaGames.OyaGames(nOyagame).CreateTempClone_GetRawPoses( _
                       nRawPos, nRawPosEnd)
                    objNewOyagames.OyaGames(nOyagame).CreateTempClone_SetRawPoses( _
                       nRawPos, nRawPosEnd)


                    ' 子亀のコピー
                    objNewOyagames.OyaGames(nOyagame).KoGames = _
                      New System.Collections.Generic.List(Of clsKoGame)( _
                      objOyaGames.OyaGames(nOyagame).KoGames.Count)

                    For nKogame As Integer = 0 To objOyaGames.OyaGames(nOyagame).KoGames.Count - 1

                        objNewOyagames.OyaGames(nOyagame).KoGames(nKogame) = _
                        objOyaGames.OyaGames(nOyagame).KoGames(nKogame).CopyInstance()

                        objNewOyagames.OyaGames(nOyagame).KoGames(nKogame).Parent = _
                         objNewOyagames.OyaGames(nOyagame)
                    Next


                Next

                For nOyagame As Integer = 0 To objOyaGames.OyaGames.Count - 1

                    ' Next Previous のコピー
                    Dim nIndex As Integer

                    nIndex = objOyaGames.OyaGames.IndexOf( _
                       objOyaGames.OyaGames(nOyagame).Previous)

                    Dim objIndex As clsOyaGame
                    If nIndex < 0 Then
                        objIndex = Nothing
                    Else
                        objIndex = objNewOyagames.OyaGames(nIndex)
                    End If
                    objNewOyagames.OyaGames(nOyagame).Previous = objIndex


                    nIndex = objOyaGames.OyaGames.IndexOf( _
                       objOyaGames.OyaGames(nOyagame).Next)

                    If nIndex < 0 Then
                        objIndex = Nothing
                    Else
                        objIndex = objNewOyagames.OyaGames(nIndex)
                    End If
                    objNewOyagames.OyaGames(nOyagame).Next = objIndex



                    ' 子亀のReffer,Reffered を書き直す
                    For nKogame As Integer = 0 To objOyaGames.OyaGames(nOyagame).KoGames.Count - 1

                        Dim objKogame As clsKoGame

                        With objOyaGames.OyaGames(nOyagame)
                            objKogame = .KoGames(nKogame).Reffer

                            .KoGames(nKogame).Reffer = _
                             clsBlockChains.CreateTempClone_GetNewKoGame(objKogame, _
                                objOyaGames, objNewOyagames)

                        End With

                        If objKogame.IsClsCash Then
                            With objKogame.ToClsCash
                                If .Reffereds Is Nothing Then
                                    Continue For
                                End If

                                If .Reffereds.Count > 0 Then
                                    For nReffed As Integer = 0 To .Reffereds.Count - 1

                                        .Reffereds(nReffed) = _
                                             clsBlockChains.CreateTempClone_GetNewKoGame(.Reffereds(nReffed), _
                                              objOyaGames, objNewOyagames)
                                    Next
                                End If
                            End With
                        End If
                    Next

                Next






                ' 親亀、子亀はこれで多分書き換えた・・・・はず？

                ' あとはキャッシュマネージャーのコピーか…。
                ' すっげーめんどくせーな～～～～。

                With objNewOyagames
                    .mCashImageManager = objOyaGames.mCashImageManager.CopyInstance(objOyaGames, objNewOyagames)
                End With

                Return objNewOyagames

            End Function


            ' reffer,reffereds 用に新しい参照先の子亀を返す
            Friend Shared Function CreateTempClone_GetNewKoGame(ByVal objOldKoGame As clsKoGame, _
                 ByVal objOldOyaGames As clsBlockChains, _
                 ByVal objNewOyaGames As clsBlockChains) As clsKoGame

                If objOldKoGame Is Nothing Then
                    Return objOldKoGame
                End If

                Dim nIndex1 As Integer
                Dim nIndex2 As Integer
                nIndex1 = objOldOyaGames.OyaGames.IndexOf(objOldKoGame.Parent)
                nIndex2 = objOldKoGame.Parent.KoGames.IndexOf(objOldKoGame)

                Return objNewOyaGames.OyaGames(nIndex1).KoGames(nIndex2)


            End Function




            Friend Function CreateTempClone_GetCurKameNo() As Integer
                Return mCurrentOyagame
            End Function




        End Class


        Friend Class clsCashImage
            Implements System.Collections.Generic.IComparer(Of clsCashImage)



            Private mobjCash As clsCashed
            Friend DataLevel As Integer
            Private mRefferEndPos As Integer
            Friend HoleLength As Integer

            Friend Sub New(ByVal objCash As clsCashed)
                mobjCash = objCash
                mRefferEndPos = -1
                Me.CashOffset = -1
                Me.HoleLength = -1
            End Sub

            Friend Property ClsCash() As clsCashed
                Set(ByVal objCash As clsCashed)
                    Me.mobjCash = objCash
                End Set
                Get
                    Return Me.mobjCash
                End Get
            End Property


            Friend Property CashOffset() As Integer
                Set(ByVal nPos As Integer)
                    mobjCash.CashPlacedPos = nPos
                End Set
                Get
                    Return mobjCash.CashPlacedPos
                End Get
            End Property


            Friend Property Reffer() As clsKoGame
                Set(ByVal objKogame As clsKoGame)
                    mobjCash.Reffer = objKogame
                End Set
                Get
                    Return mobjCash.Reffer
                End Get
            End Property

            Friend Property Reffereds() As System.Collections.Generic.List(Of clsReffer)
                Set(ByVal objReffer As System.Collections.Generic.List(Of clsReffer))
                    mobjCash.Reffereds = objReffer
                End Set
                Get
                    Return mobjCash.Reffereds
                End Get
            End Property

            Friend Property Disabled() As Boolean
                Set(ByVal bValue As Boolean)
                    mobjCash.Disabled = bValue
                End Set
                Get
                    Return mobjCash.Disabled
                End Get
            End Property

            Friend Property DisabledReason() As clsKoGame.DisabledReasons
                Set(ByVal enmValue As clsKoGame.DisabledReasons)
                    mobjCash.DisabledReason = enmValue
                End Set
                Get
                    Return mobjCash.DisabledReason
                End Get
            End Property

            Friend Property Parent() As clsOyaGame
                Set(ByVal objOyagame As clsOyaGame)
                    mobjCash.Parent = objOyagame
                End Set
                Get
                    Return mobjCash.Parent
                End Get
            End Property

            Friend Property Length() As Integer
                Set(ByVal nLength As Integer)
                    mobjCash.Length = nLength
                End Set
                Get
                    Return mobjCash.Length
                End Get
            End Property

            Friend Property RawOffset() As Integer
                Set(ByVal nRawOffset As Integer)
                    mobjCash.Length = nRawOffset
                End Set
                Get
                    Return mobjCash.RawOffset
                End Get
            End Property

            Friend Property CanInCashes() As System.Collections.Generic.List(Of clsCashed)
                Set(ByVal objCashes As System.Collections.Generic.List(Of clsCashed))
                    mobjCash.CanInCashes = objCashes
                End Set
                Get
                    Return mobjCash.CanInCashes
                End Get
            End Property




            Friend Function GetRefferEnd() As Integer
                If mRefferEndPos = -1 Then
                    Dim nRefEndPos As Integer
                    nRefEndPos = -1
                    For Each objRef As clsReffer In Me.Reffereds
                        nRefEndPos = System.Math.Max(objRef.FromOffset + objRef.Length, nRefEndPos)
                    Next
                    Return nRefEndPos
                Else
                    Return mRefferEndPos
                End If
            End Function
            Friend Sub ResetRefferEnd()
                mRefferEndPos = -1
            End Sub



            Friend Function IsLive(ByVal objImage As clsCashImage) As Boolean
                ' この位置に挿入出来るか？
                Dim nRefEndPos As Integer
                nRefEndPos = Me.GetRefferEnd()

                If objImage.GetRefferEnd() < Me.RawOffset Then
                    ' 被らない
                    Return False
                End If

                If Me.GetRefferEnd() < objImage.RawOffset Then
                    ' 被らない
                    Return False
                End If

                Return True
            End Function

            Friend Function IsCashCross(ByVal nCashPos As Integer, ByVal nLength As Integer) As Boolean
                ' 場所が被るか？
                If Me.CashOffset > nCashPos + nLength Then
                    Return False
                End If

                If Me.CashOffset + Me.Length < nCashPos Then
                    Return False
                End If

                Return True
            End Function


            Friend Function CompareToCashOffet_list(ByVal x As System.Collections.Generic.List(Of clsCashImage), _
                                                    ByVal y As System.Collections.Generic.List(Of clsCashImage)) As Integer
                Return x(0).CashOffset.CompareTo(y(0).CashOffset)
            End Function

            Friend Function CompareToCashOffet(ByVal x As clsCashImage, ByVal y As clsCashImage) As Integer
                Return x.CashOffset.CompareTo(y.CashOffset)
            End Function

            Friend Function CompareToDataLevel(ByVal x As clsCashImage, ByVal y As clsCashImage) As Integer
                Return x.DataLevel.CompareTo(y.DataLevel)
            End Function



            Friend ReadOnly Property CashOffsetEnd() As Integer
                Get
                    Return Me.CashOffset + Me.Length
                End Get
            End Property

            Friend Function CopyInstance( _
              ByVal objOldBlockCain As clsBlockChains, _
              ByVal objNewBlockCain As clsBlockChains) As clsCashImage
                Dim objNewCashImage As clsCashImage
                Dim objNewCash As clsCashed

                objNewCash = clsBlockChains.CreateTempClone_GetNewKoGame( _
                    Me.mobjCash, _
                    objOldBlockCain, objNewBlockCain)


                objNewCashImage = New clsCashImage(objNewCash)
                objNewCashImage.DataLevel = Me.DataLevel
                objNewCashImage.CopyInstance_SetmRefferEndPos(Me.mRefferEndPos)

                Return objNewCashImage

            End Function

            Friend Sub CopyInstance_SetmRefferEndPos(ByVal nRefferEndPos As Integer)
                Me.mRefferEndPos = nRefferEndPos
            End Sub

            Public Function Compare(ByVal x As clsCashImage, ByVal y As clsCashImage) As Integer Implements System.Collections.Generic.IComparer(Of clsCashImage).Compare

            End Function
        End Class


        ' キャッシュアドレス・clsCashImage登録用のソートリストクラス
        Friend Class clsMultiSortedList
            Implements System.Collections.Generic.IComparer(Of System.Collections.Generic.List(Of clsCashImage))






            ' １つのキーに複数のTValue を登録出来て、
            ' かつ「隣」のキー・値ペアがすぐに取得出来る
            ' おっせーけどしょうがねぇべ…。
            ' ハッシュの改造版

            Private mList As System.Collections.Generic.List(Of System.Collections.Generic.List(Of clsCashImage))

            Protected Overrides Sub Finalize()
                ' 念のため傘下のList<T>を全部クリアしておく
                For Each value As System.Collections.Generic.List(Of clsCashImage) In mList
                    value.Clear()
                Next
            End Sub

            Friend Sub Add(ByVal key As Integer, ByVal value As clsCashImage)

                ' http://programmers.high-way.info/vb/list-remove.html
                ' うわList型の条件検索すっげー便利だわこのHPによると…。
                Dim glstValueList As System.Collections.Generic.List(Of clsCashImage)

                ' key に相当するリストはあるか？
                Dim nIndex As Integer
                Dim lSearch As New System.Collections.Generic.List(Of clsCashImage)(1)

                lSearch(0) = New clsCashImage(New clsCashed())
                lSearch(0).CashOffset = key
                'nIndex = mList.BinarySearch(lSearch, AddressOf lSearch(0).CompareToCashOffet_list)
                nIndex = mList.BinarySearch(lSearch, lSearch(0))

                If nIndex >= 0 Then
                    glstValueList = mList(nIndex)
                Else
                    glstValueList = New System.Collections.Generic.List(Of clsCashImage)()
                    nIndex = -nIndex
                    mList.Insert(nIndex, glstValueList)
                End If

                glstValueList.Add(value)


            End Sub

            Default Friend ReadOnly Property Item(ByVal key As Integer) As System.Collections.Generic.List(Of clsCashImage)
                Get
                    Return Me.GetKeyList(key)
                End Get
            End Property

            Friend ReadOnly Property ContainsKey(ByVal key As Integer) As Boolean
                Get
                    Dim glstValueList As System.Collections.Generic.List(Of clsCashImage)

                    glstValueList = Me.GetKeyList(key)
                    If glstValueList Is Nothing Then
                        Return False
                    Else
                        Return True
                    End If
                End Get
            End Property

            Friend Property ListItem(ByVal nNo As Integer) As System.Collections.Generic.List(Of clsCashImage)
                Set(ByVal lst As System.Collections.Generic.List(Of clsCashImage))
                    Me.mList(nNo) = lst
                End Set
                Get
                    Return Me.mList(nNo)
                End Get
            End Property

            Friend ReadOnly Property ListCount() As Integer
                Get
                    Return Me.mList.Count
                End Get
            End Property




            Private Function GetKeyList(ByVal key As Integer) As System.Collections.Generic.List(Of clsCashImage)

                ' key に相当するリストはあるか？
                Dim nIndex As Integer
                Dim lSearch As New System.Collections.Generic.List(Of clsCashImage)(1)
                Dim glstValueList As System.Collections.Generic.List(Of clsCashImage)

                lSearch(0) = New clsCashImage(New clsCashed())
                lSearch(0).CashOffset = key

                ' メンバや関数を渡すのではなく、
                ' インターフェイスを実装したクラスインスタンスを渡せばいいらしい。
                'Dim comparer As System.Collections.Generic.IComparer(Of System.Collections.Generic.List(Of clsCashImage))
                'comparer = Me

                nIndex = Me.mList.BinarySearch(lSearch, Me)

                If nIndex >= 0 Then
                    glstValueList = mList(nIndex)
                Else
                    glstValueList = Nothing
                End If

                Return glstValueList

            End Function

            Friend Function GetNextCashPos(ByVal key As Integer) As Integer

                Dim nIndex As Integer
                Dim lSearch As New System.Collections.Generic.List(Of clsCashImage)(1)

                lSearch(0) = New clsCashImage(New clsCashed())
                lSearch(0).CashOffset = key

                nIndex = Me.mList.BinarySearch(lSearch, Me)

                If nIndex < 0 Then
                    ' 通常はこういう事ないけれど…。
                    nIndex = -nIndex
                Else
                    nIndex += 1
                    If nIndex >= Me.mList.Count Then
                        Return -1
                    End If
                End If

                Return (Me.mList(nIndex))(0).CashOffset
            End Function

            Friend Sub Remove(ByVal nPos As Integer, ByVal objRemoveImage As clsCashImage)
                Dim lstImages As System.Collections.Generic.List(Of clsCashImage)
                
                lstImages = Me.GetKeyList(nPos)
                If lstImages Is Nothing Then
                    ' とりあえず念のため終了しとく
                    Return
                End If

                lstImages.Remove(objRemoveImage)
                If lstImages.Count = 0 Then
                    ' ・・・ポインタ指定で消えるのかなこれ
                    Me.mList.Remove(lstImages)
                End If

            End Sub


            Friend Function CompareTo(ByVal x As System.Collections.Generic.List(Of clsCashImage), ByVal y As System.Collections.Generic.List(Of clsCashImage)) As Integer Implements System.Collections.Generic.IComparer(Of System.Collections.Generic.List(Of clsCashImage)).Compare
                Return x(0).CashOffset.CompareTo(y(0).CashOffset)
            End Function
        End Class


        ' キャッシュイメージ操作用のサブルーチン群
        Friend Class clsCashImageManager
            Private mMaxRawSize As Integer
            Private mCashImages As System.Collections.Generic.List(Of clsCashImage)

            ' キャッシュ配置位置からキャッシュオブジェクトを返す？
            Friend mCashPoitionIntend As clsMultiSortedList

            Private mnCashSize As Integer

            Friend Sub New()
                Me.mCashImages = New System.Collections.Generic.List(Of clsCashImage)(0)
            End Sub

            Default Friend Overloads Property Item(ByVal nNo As Integer) As clsCashImage
                Set(ByVal objImages As clsCashImage)
                    Me.mCashImages(nNo) = objImages
                End Set
                Get
                    Return Me.mCashImages(nNo)
                End Get
            End Property


            Friend Property Images() As System.Collections.Generic.List(Of clsCashImage)
                Set(ByVal lstImages As System.Collections.Generic.List(Of clsCashImage))
                    Me.mCashImages = lstImages
                End Set
                Get
                    Return Me.mCashImages
                End Get
            End Property

            Friend Property UnzipDataSize() As Integer
                Set(ByVal nSize As Integer)
                    Me.mMaxRawSize = nSize
                End Set
                Get
                    Return Me.mMaxRawSize
                End Get
            End Property

            Friend Property CashSize() As Integer
                Set(ByVal nSize As Integer)
                    Me.mnCashSize = nSize
                End Set
                Get
                    Return Me.mnCashSize
                End Get
            End Property

            Friend Function TryAddCashImage(ByVal objImage As clsCashImage) As Boolean


                ' キャッシュ挿入位置を決定する

                Dim objImages As clsCashImageManager
                Dim nCash As Integer
                Dim nReffedPos As Integer


                objImages = Me
                nReffedPos = objImage.RawOffset



                If Me.mCashImages.Count = 0 Then
                    ' 最初のはとりあえず先頭に置く
                    ' DataLevel が高いのが来たらどんどん後ろに下げる
                    objImage.CashOffset = 0

                    Me.mCashImages.Add(objImage)
                    Me.mCashPoitionIntend.Add(0, objImages(nCash))
                    Exit Function
                End If





                Dim nCashPos As Integer


                ' 0 から始まる位置に、新しいキャッシュを置こうとする。
                ' 空いてなかったら優先順位を比較して、
                ' 自分優先だったらどいてもらう感じ？



                ' 一度キャッシュイメージを作る
                nCash = 0
                nCashPos = 0

                ' 一度仮のキャッシュイメージを作る方法は
                ' なんか間違ってる気がする
                ' けどとりあえず使う。
                Dim nUsedCashSize As Integer
                Dim objCurentImage As New System.Collections.Generic.List(Of clsCashImage)(0)

                nUsedCashSize = 0
                Do While nCash < objImages.Images.Count

                    If objImages(nCash).IsCashCross(nCashPos, objImage.Length) = False Then
                        ' この位置はまだいいらしい。
                        nCash += 1
                        Continue Do
                    End If
                    If objImages(nCash).IsLive(objImage) = False Then
                        ' この位置はまだいいらしい。
                        nCash += 1
                        Continue Do
                    End If

                    nUsedCashSize += objImages(nCash).Length
                    objCurentImage.Add(objImages(nCash))
                    nCash += 1
                Loop



                If Me.IsCashOver(nUsedCashSize, objImage.Length) = True Then
                    ' キャッシュ優先度が低い物から参照を解除する


                    ' 優先度が一番低い物を解除して、試しに入れてみる。
                    ' を繰り返す羽目になるよな。
                    ' これも面倒臭いな～～～～～～。

                    'Dim dltPointer_Sort = Function _
                    '           (x As System.Collections.Generic.List(Of clsCashImage), y As System.Collections.Generic.List(Of clsCashImage)) _
                    '            x(0).CashOffset.CompareTo(y(0).CashOffset)

                    If objCurentImage.Count > 0 Then
                        ' これ、ソートってまさか・・・。０からだよな？？？				
                        'objCurentImage.Sort( Function (ByVal x as clsCashImage, ByVal y as clsCashImage ) as Integer	return x.DataLevel.CompareTo( y.DataLevel ) )
                        objCurentImage.Sort(AddressOf objCurentImage(0).CompareToCashOffet)

                        If objCurentImage(0).DataLevel > objImage.DataLevel Then
                            ' 優先度的に入れるのは無理。
                            Return False
                        End If

                    End If
                End If


                ' https://docs.microsoft.com/ja-jp/dotnet/api/system.collections.generic.list-1.sort?view=netframework-4.8
                ' programmers.high-way.info/vb/list-remove.html
                ' ラムダ式、無名関数と言うらしい。
                '
                ' VB.net のラムダ式
                'https://docs.microsoft.com/ja-jp/dotnet/visual-basic/programming-guide/language-features/procedures/lambda-expressions

                'https://smdn.jp/programming/netfx/collections/2_generic_1_list/
                ' smdn サイト自体怪しいが、Listの使い方が分かりやすい。

                If objCurentImage.Count > 0 Then
                    objCurentImage.Sort(AddressOf objCurentImage(0).CompareToCashOffet)
                End If


                Dim objPosHash As clsMultiSortedList
                objPosHash = Me.mCashPoitionIntend

                nCash = 0
                nCashPos = 0

                'Dim objCurentImage	as new System.Collections.Generic.List(Of clsCashImage )(0)
                Do While nCash < objImages.Images.Count

                    If objImages(nCash).IsCashCross(nCashPos, objImage.Length) = False Then
                        ' この位置はまだいいらしい。
                        nCash += 1
                        Continue Do
                    End If
                    If objImages(nCash).IsLive(objImage) = False Then
                        ' この位置はまだいいらしい。
                        nCash += 1
                        Continue Do
                    End If

                    'objCurentImage.Add( objImages( nCash ) )





                    ' 連続自己参照の場合が全く考慮されてなかったりするんだよな・・・・。
                    ' 







                    ' 位置衝突。
                    ' どかすか、自分が後ろに下がる。



                    ' 優先度が低いフレームはぜんぶ後ろに回すｗ
                    ' 入りきるまでフレームを後ろに回す

                    ' 優先度が高い方を前にする
                    ' ・・・じゃなくって、
                    ' 開いてる「ポインタ位置」を極力利用する

                    If objImages(nCash).DataLevel < objImage.DataLevel Then
                        ' どかす場合

                        If objImages(nCash).Length < objImage.Length Then
                            ' ぱっと見でどかしても入りきらないかも知れない場合

                            ' この「右隣」のキャッシュも使わないと入らないんじゃないの？
                            Dim nNextCash As Integer


                            nNextCash = Me.GetNearestCash_FromSortedList( _
                                objImages(nCash).CashOffsetEnd, objCurentImage)
                            If nNextCash = -1 Then
                                ' nCash が一番ケツのキャッシュだったら

                                ' objImages( nCash )を objImage の後ろ、最後に移動
                                Dim nNewCashPos As Integer

                                nNewCashPos = objPosHash.GetNextCashPos(objImages(nCash).CashOffset + objImage.Length)
                                If nNewCashPos = -1 Then
                                    nNewCashPos = objImages(nCash).CashOffset + objImage.Length
                                End If

                                If Me.IsCashOver(nNewCashPos, objImages(nCash).Length) = True Then
                                    ' キャッシュ位置溢れ
                                    Return False
                                End If
                                Dim bRet As Boolean
                                bRet = Me.MoveCashToBack(nCash, nNewCashPos)
                                If bRet = False Then
                                    ' キャッシュ位置溢れ
                                    Return False
                                End If

                                objCurentImage.Sort(AddressOf objCurentImage(0).CompareToCashOffet)

                                nCashPos = objImages(nCash).CashOffset
                                Exit Do

                            End If


                            ' objImages( nhash ) をとりあえず後ろにどかす
                            ' ・・・んだけど、この際、複数のキャッシュをどかす必要に迫られた場合
                            ' これも対応しなきゃいけない。
                            ' 
                            Dim nMoveCashesPos As Integer
                            Dim nOldCashOffset As Integer
                            nOldCashOffset = objImages(nCash).CashOffset

                            nMoveCashesPos = objImages(nCash).CashOffset + objImage.Length
                            ' 別にもっと手前に置いてもいいんだけどさ…
                            ' とりあえずなるべく「同じ場所」に置いた方が
                            ' ハフマン符号の「効率」が上がりそうだから…(実際にはそんな極端に
                            '    効率が上がる訳ではない)
                            nMoveCashesPos = objPosHash.GetNextCashPos(nMoveCashesPos)
                            If nMoveCashesPos = -1 Then
                                nMoveCashesPos = objImages(nCash).CashOffset + objImage.Length
                                If Me.IsCashOver(nMoveCashesPos, objImages(nCash).Length) = True Then
                                    ' キャッシュ位置溢れ
                                    Return False
                                End If

                            End If

                            With Nothing
                                Dim bRet As Boolean
                                bRet = Me.MoveCashToBack(nCash, nMoveCashesPos)
                                If bRet = False Then
                                    ' キャッシュ位置溢れ
                                    Return False
                                End If
                            End With
                            objCurentImage.Sort(AddressOf objCurentImage(0).CompareToCashOffet)

                            nMoveCashesPos += objImages(nCash).Length

                            ' nOldCashOffset ～ nOldCashOffset + objImage.Length 区間にあったキャッシュも
                            ' 合わせて後ろに移動させる



                            ' こんな感じかなぁ…。

                            Dim nOldCashesOffset As Integer

                            nOldCashesOffset = nOldCashOffset + objImages(nCash).Length
                            Do

                                ' ソートして順序変わってるから念のためもう一度取って来る。
                                nNextCash = Me.GetNearestCash_FromSortedList( _
                                   nOldCashesOffset, objCurentImage)
                                If nNextCash = -1 Then
                                    Exit Do
                                End If

                                If objImages(nNextCash).CashOffset >= nOldCashOffset + objImage.Length Then
                                    Exit Do
                                End If
                                ' objImage が被りそうなら移動する

                                Dim nRet As Integer
                                nRet = objPosHash.GetNextCashPos(nMoveCashesPos)
                                If nRet = -1 Then
                                    'nMoveCashesPos = nMoveCashesPos
                                Else
                                    nMoveCashesPos = nRet
                                End If


                                If Me.IsCashOver(nMoveCashesPos, objImages(nNextCash).Length) = True Then
                                    ' キャッシュ位置溢れ
                                    Return False
                                End If


                                If Me.MoveCashToBack(nNextCash, nMoveCashesPos) = False Then
                                    ' キャッシュ位置溢れ
                                    Return False
                                End If
                                objCurentImage.Sort(AddressOf objCurentImage(0).CompareToCashOffet)

                                nMoveCashesPos += objImages(nNextCash).Length
                                nOldCashesOffset += objImages(nNextCash).Length

                            Loop


                            nCashPos = objImages(nCash).CashOffset
                            Exit Do



                        Else
                            ' 一個だけどかす場合
                            Dim nCashMovePos As Integer
                            Dim nRet As Integer

                            nCashMovePos = objImages(nCash).CashOffset + objImage.Length
                            nRet = objPosHash.GetNextCashPos(nCashMovePos)
                            If nRet = -1 Then
                                'nMoveCashesPos = nMoveCashesPos
                            Else
                                nCashMovePos = nRet
                            End If

                            If Me.MoveCashToBack(nCash, nCashMovePos) = False Then
                                ' キャッシュ位置溢れ
                                Return False
                            End If

                            objCurentImage.Sort(AddressOf objCurentImage(0).CompareToCashOffet)
                            nCashPos = objImages(nCash).CashOffset
                            Exit Do
                        End If

                    End If

                    ' ぶつかったキャッシュの後ろに仮配置して再評価
                    With objImages(nCash)
                        Dim nRet As Integer
                        nCash = 0
                        nCashPos = .CashOffsetEnd
                        nRet = objPosHash.GetNextCashPos(nCashPos)
                        If nRet = -1 Then
                            'nCashPos = nCashPos
                        Else
                            nCashPos = nRet
                        End If
                    End With

                    If Me.IsCashOver(nCashPos, objImage.Length) = True Then
                        ' キャッシュ位置溢れ
                        Return False
                    End If


                    Continue Do
                Loop


                ' キャッシュ位置ハッシュに登録
                objPosHash.Add(nCashPos, objImage)
                ' 位置確定
                objImage.CashOffset = nCashPos


                Return True



            End Function





            ' 再起できるようにｗ
            Private Function MoveCashToBack(ByVal nCashToMove As Integer, ByVal nCashPos As Integer) As Boolean
                Dim objImages As clsCashImageManager
                Dim objImage As clsCashImage
                Dim nCash As Integer
                Dim objPosHash As clsMultiSortedList

                objPosHash = Me.mCashPoitionIntend

                Dim bRet As Boolean

                objImages = Me
                objImage = objImages(nCashToMove)

                nCash = 0
                Do While nCash < objImages.Images.Count

                    If objImages(nCash).IsCashCross(nCashPos, objImage.Length) = False Then
                        ' この位置はまだいいらしい。
                        nCash += 1
                        Continue Do
                    End If
                    If objImages(nCash).IsLive(objImage) = False Then
                        ' この位置はまだいいらしい。
                        nCash += 1
                        Continue Do
                    End If

                    ' キャッシュ配置位置競合
                    ' 場所のハッシュから次の場所を見つける？



                    ' 場所がぶつかったキャッシュだったら
                    ' ぶつかったキャッシュを後ろに下げる？
                    ' その後ろを使うという選択肢は？

                    Dim nNewCashPos As Integer
                    nNewCashPos = objPosHash.GetNextCashPos(objImages(nCash).CashOffsetEnd)
                    If nNewCashPos = -1 Then
                        nNewCashPos = objImages(nCash).CashOffsetEnd
                    End If
                    If Me.IsCashOver(nNewCashPos, objImages(nCash).Length) = True Then
                        Return False
                    End If


                    bRet = Me.MoveCashToBack(nCash, nNewCashPos)
                    If Not bRet Then
                        Return False
                    End If

                    Exit Do


                    nCash += 1
                Loop

                ' 一つもぶつからなかったらキャッシュ位置確定
                objPosHash.Remove(objImage.CashOffset, objImage)

                objImage.CashOffset = nCashPos

                objPosHash.Add(objImage.CashOffset, objImage)

                Return True

            End Function


            ' 一番右に「近い」キャッシュイメージのリスト番号を得る
            Private Function GetNearestCash_FromSortedList(ByVal nPos As Integer, _
               ByVal objImages As System.Collections.Generic.List(Of clsCashImage)) As Integer
                ' 二分探索
                '  https://qiita.com/taskie/items/b4e45e2005aa38e90bcb
                '  https://docs.microsoft.com/ja-jp/dotnet/api/system.collections.generic.list-1.binarysearch?view=netframework-4.8

                ' binarySeach メソッドを使えば二分探索が簡単に出来るらしい。
                Dim objPos As clsCashImage
                Dim nRet As Integer

                objPos = New clsCashImage(New clsCashed)
                objPos.CashOffset = nPos
                nRet = objImages.BinarySearch(objPos, objPos)

                ' で、マイナスの場合は挿入位置が出るらしい。便利だ！


                If nRet < 0 Then
                    nRet = -nRet
                ElseIf nRet = objImages.Count - 1 Then
                    If objImages(nRet).CashOffsetEnd < nPos Then
                        ' 末尾に追加するときは-1
                        Return -1
                    End If
                End If


                Return nRet
            End Function

            Friend ReadOnly Property IsCashOver(ByVal nPos As Integer, ByVal nLength As Integer) As Boolean
                Get
                    If nPos + nLength >= Me.mnCashSize Then
                        ' キャッシュ位置溢れ
                        Return True
                    Else
                        Return False
                    End If
                End Get
            End Property

            Friend Function CopyInstance(ByVal objOldOyagames As clsBlockChains, ByVal objNewOyagames As clsBlockChains) As clsCashImageManager

                Dim objNewCashImageManager As New clsCashImageManager

                objNewCashImageManager.UnzipDataSize = Me.UnzipDataSize
                objNewCashImageManager.CashSize = Me.CashSize
                objNewCashImageManager.Images = _
                        New System.Collections.Generic.List(Of clsCashImage)(Me.mCashImages.Count)

                If objNewCashImageManager.Images.Count > 0 Then

                    For nCash As Integer = 0 To objNewCashImageManager.Images.Count - 1

                        objNewCashImageManager.Images(nCash) = _
                                        Me.mCashImages(nCash).CopyInstance(objOldOyagames, objNewOyagames)
                    Next

                End If

                ' キャッシュ位置の配列もコピーせんと・・・
                objNewCashImageManager.mCashPoitionIntend = New clsMultiSortedList()
                If Me.mCashPoitionIntend.ListCount > 0 Then
                    For nCnt As Integer = 0 To Me.mCashPoitionIntend.ListCount - 1
                        Dim lstImage As System.Collections.Generic.List(Of clsCashImage)
                        lstImage = Me.mCashPoitionIntend.ListItem(nCnt)

                        If lstImage.Count > 0 Then
                            For nImage As Integer = 0 To lstImage.Count - 1
                                lstImage(nImage) = lstImage(nImage).CopyInstance(objOldOyagames, objNewOyagames)
                            Next
                        End If
                    Next

                End If

                Return objNewCashImageManager

			End Function


            ''' <summary>
            ''' 
            ''' </summary>
            ''' <param name="objImage"></param>
            ''' <param name="objCurentImage"></param>
            ''' <returns></returns>
            ''' <remarks></remarks>
			Friend Function CreateCashImage_CreateCashImageAndEvaluate( _
				          ByVal objImage As clsCashImage, _
				          ByVal objCurentImage As System.Collections.Generic.List(Of clsCashImage), _ 
				          ByVal objBlockChains as clsBlockChains ) As Boolean


	            Dim objImages As clsCashImageManager
	            Dim objPosHash As clsMultiSortedList

	            objImages = Me
	            objPosHash = Me.mCashPoitionIntend




	            ' 参照がクソでかい場合と
	            ' 自己連続参照の場合の二通りあるな…。

	            ' キャッシュ優先度によって決める。
	            Dim nAllCashLevels As Integer
	            nAllCashLevels = 0
	            For Each objCashImage As clsCashImage In objCurentImage
	                nAllCashLevels += objCashImage.DataLevel
	            Next
	            If nAllCashLevels < objImage.DataLevel Then

	                ' 参照を全て削除する。
	                For Each objCashImage As clsCashImage In objCurentImage
	                    clsBlockChains.DisableCash( _
	                         objCashImage.ClsCash, _
	                         clsKoGame.DisabledReasons.AddedCashIsOverCashSizeAndAlreadyAddedAllCashAndReffersAreDisabled, _
	                         objBlockChains )

	                    ' 確定済みキャッシュイメージから削除
	                    objImages.Images.Remove(objCashImage)
	                Next




	                ' キャッシュ位置ハッシュに登録
	                Dim nCashPos As Integer
	                nCashPos = 0

	                ' これ登録いるんかいな・・・。先頭なのに。
	                objPosHash.Add(nCashPos, objImage)
	                ' 位置確定
	                objImage.CashOffset = nCashPos

	                ' 確定済みキャッシュイメージに追加
	                objImages.Images.Add(objImage)

	            Else
	                ' この参照キャッシュの追加を諦める。
	                clsBlockChains.DisableCash( _
	                  objImage.ClsCash, _
	                  clsKoGame.DisabledReasons.TriedAddingCashIsOverCashSizeButFailedToAddForThisCashIsLowetstDataLevel, _
	                  objBlockChains )

	            End If

	            Return True


	        End Function

            ''' <summary>
            ''' 
            ''' </summary>
            ''' <param name="objImage"></param>
            ''' <param name="objCurentImage"></param>
            ''' <returns></returns>
            ''' <remarks></remarks>
			Friend Function CreateCashImage_TryAddCashMemoryOveredCash( _
				          ByVal objImage As clsCashImage, _
				          ByVal objCurentImage As System.Collections.Generic.List(Of clsCashImage), _ 
				          ByRef objBlockChains as clsBlockChains ) As Boolean


	            Dim objImages As clsCashImageManager
	            Dim objPosHash As clsMultiSortedList

	            objImages = Me
	            objPosHash = Me.mCashPoitionIntend

	            ' キャッシュ優先度が低い物から参照を解除する


	            ' 優先度が一番低い物を解除して、試しに入れてみる。
	            ' を繰り返す羽目になるよな。

	            ' これも面倒臭いな～～～～～～。

	            ' これ、ソートってまさか・・・。０からだよな？？？
                If objCurentImage.Count > 0 Then
                    objCurentImage.Sort(AddressOf objCurentImage(0).CompareToDataLevel)
                End If

	            If objCurentImage(0).DataLevel > objImage.DataLevel Then
	                ' 優先度的に入れるのは無理。


	                clsBlockChains.DisableCash( _
	                     objImage.ClsCash, _
	                     clsKoGame.DisabledReasons.TriedAddingCashIsFailedForThisCashIsLowetstDataLevel, _
	                     objBlockChains )

	                return true
	            End If

	            ' いっこずつ解除を試して入れる・・・・
	            ' なんて面倒臭いロジックかける訳ないじゃんｗ
	            ' 解除前のデータを一度全部コピーして保存しとかなきゃ。
	            ' 親亀も子亀も、ぜんぶコピーしなきゃ駄目だこれ・・・。



	            ' レベルの和、サイズを計算
	            Dim nDeleteCash As Integer
	            Dim nDecleaseByte As Integer
	            Dim nDecleaseLevel As Integer

	            With Nothing
	                Dim bCashAddFail As Boolean
	                nDeleteCash = 0
	                nDecleaseByte = 0
	                nDecleaseLevel = 0
	                bCashAddFail = True
	                Do While nDeleteCash < objCurentImage.Count
	                    nDecleaseByte += objCurentImage(nDeleteCash).Length
	                    nDecleaseLevel += objCurentImage(nDeleteCash).DataLevel

	                    If nDecleaseLevel > objImage.DataLevel Then
	                        ' 追加しようとするキャッシュより削除するキャッシュ群の方が
	                        ' 優先レベルが低いので、キャッシュの追加を諦める。
	                        bCashAddFail = True
	                        Exit Do
	                    End If

	                    If objImages.IsCashOver(nUsedCashSize - nDecleaseByte, objImage.Length) = False Then
	                        ' とりあえず場所が空いたので追加を試みる。
	                        bCashAddFail = False
	                        Exit Do
	                    End If

	                    nDeleteCash += 1
	                Loop

	                If bCashAddFail Then
	                    ' この参照キャッシュの追加を諦める。
	                    clsBlockChains.DisableCash( _
	                      objImage.ClsCash, _
	                      clsKoGame.DisabledReasons.TriedAddingCashIsCashSizeOverAndTringToDeleteCashesAreHigherDataLevelThanThigCash, _
	                     objBlockChains )

		                return true
	                End If
	            End With

	            ' mBlockChainをだいたい全部ディープコピー
	            ' 確定出来たらこれと mBlockChain を入れ替えるため。
	            Dim objTempOyaGames As clsBlockChains
	            objTempOyaGames = Me.mBlockChains.CreateTempClone()


				Dim objCurrentImagesTemp as new System.Collections.Generic.List(Of clsCashImage)(0)


	            ' 指定データレベルまでのキャッシュ削除を試みる。

	            Dim lstDeleteCashes As New System.Collections.Generic.List(Of clsCashed)(nDeleteCash + 1)

	            ' 削除予定のキャッシュ一覧(コピー側)を作成
	            With Nothing
	                Dim nCash As Integer
	                nCash = 0
	                Do While nCash <= nDeleteCash

	                    Dim objTempCash As clsCashed

	                    objTempCash = clsBlockChains.CreateTempClone_GetNewKoGame( _
	                                 objCurentImage(nCash).ClsCash, _
	                                 objBlockChains, objTempOyaGames)

	                    lstDeleteCashes(nCash) = objTempCash

	                    nCash += 1
	                Loop

					
					' CurrentImage のtemp版を作る
					Dim objNewCashImageTemp as clsCashImage
	                nCash = nDeleteCash + 1
	                Do While nCash < objCurrentImages.Count
						
						objNewCashImageTemp = new clsCashImage( _ 
	                				 clsBlockChains.CreateTempClone_GetNewKoGame( _
											objCurentImage( nCash ).ClsCash, _
											objBlockChains, objTempOyaGames ) )

	                	objCurrentImagesTemp.Add( objNewCashImageTemp )

	                	nCash += 1
	                Loop

					' objImage のコピーを作る
					Dim objImageTemp as clsCashImage
					With Nothing
						Dim objCashTemp as clsCashed
						objCashTemp = 	 clsBlockChains.CreateTempClone_GetNewKoGame( _
												objCurentImage( nCash ).ClsCash, _
												objBlockChains, objTempOyaGames )
						objImageTemp = new clsCashImage( objCashTemp )
					End With

	                ' 一時的なブロックチェーンから参照も含めて削除
	                nCash = 0
	                Do While nCash <= nDeleteCash
	                    clsBlockChains.DisableCash( _
	                     lstDeleteCashes(nCash), _
	                     clsKoGame.DisabledReasons.DeletedForCashIsOverAndThisRefferIsLowerDataLevelThanTryingAddedCash, _
	                          objTempOyaGames)

	                    nCash += 1
	                Loop


	            End With



                ' 場所は一応は空いたはずなので、キャッシュ追加をやってみる。

                ' 念のためキャッシュイメージから「空いている場所」を検索してみる。

				' キャッシュメモリが一杯なのにこれ以上移動を繰り返す意味は果たして
				' あるだろうか？？？
				' キャッシュの移動を繰り返せば入る可能性はあるけど、多分絶望的な
				' 気がする。
				' とりあえず、「空きスペースがあるなら」にする。
				' 一つ削っては挿入をためし・・・という感じにする？
				
				If objCurrentImagesTemp.Count = 0 Then
					' 先頭に確定
					
					' 参照渡しで新しい BlockChains を渡せるかどうか…。
					
					
					
					' これでコピー全部入れ替え出来ると思うけど…。
					objBlockChains = objTempOyaGames
					
					Dim objPosHash As clsMultiSortedList
	                objPosHash = objTempOyaGames.mCashPoitionIntend

					Dim nCashPos as Integer
	                ' キャッシュ位置ハッシュに登録
	                objPosHash.Add(nCashPos, objImageTemp)
	                ' 位置確定
	                objImageTemp.CashOffset = nCashPos
	                
	                return true

				End If


				' キャッシュが入る所一覧を作成
                Dim objCanInsertPlaces As New System.Collections.Generic.List(Of clsCashImage)(0)

				objCurrentImagesTemp.Sort( AddressOf objCurrentImagesTemp( 0 ).CompareToCashOffet )
				Dim nImage		as Integer
				
				nImage = 1
				Do While nImage < objCurrentImagesTemp.Count + 1
					
						If nImage < objCurrentImagesTemp.Count Then
	                		objCurrentImagesTemp( nImage-1 ).HoleLength = _
                					 objCurrentImage( nImage ).CashOffset - _ 
                						objCurrentImage( nImage - 1 ).CashOffsetEnd
                		Else
							objCurrentImagesTemp( nImage-1 ).HoleLength = _
								Me.mnCashSize - objCurrentImagesTemp( nImage ).CashOffsetEnd
                		End If
                		If objCurrentImage( nImage-1 ).HoleLength >= objImage.Length Then
							objCanInsertPlaces.Add( nImage-1 )
                		End If
					
					nImage += 1
				Loop

				' 問題はどこのホールから使うかなんだよな…。
				If objCanInsertPlaces.Count > 0 Then
					
					' 断片化を最も避ける？
					' 一番近い参照元にする？
					' 一番長いスペースを用意する？
					' 一番ピッタリはまるスペースに入れる？
					' 参照回数が多いキャッシュ位置を極力使う？
					
					' すぐ寿命が尽きるキャッシュは極力「０」を使う。
					' 
					' 長いキャッシュが入るように、なるべく長いホールが出来るようにする。
					
					
					
					'
					'  難し過ぎる・・・後で考えよう・・・。
					'  全体のキャッシュ化の様子が分からんとどうにもならんわ。
					'
					
				End If


				' 入るまでキャッシュ削除を繰り返すｗ

                ' objImage は・・・・・。
                ' 変換するとどれになるのだろう？？？




                'objTempOyaGames.mCashImageManager.TryAddCashImage(objImage)



				return false....true?

			End Function





	        Friend Function CreateCashImage_GetOyagameTopUnlocateCash() As clsOyaGame

	            Dim objCurOyagame As clsOyaGame

	            objCurOyagame = mBlockChains(0)
	            Do While objCurOyagame IsNot Nothing

	                If objCurOyagame.IsClsRawData Then
	                    objCurOyagame = objCurOyagame.Next
	                    Continue Do
	                End If

	                Dim objCash As clsCashed
	                Dim nKogame As Integer
	                nKogame = 0
	                objCash = Nothing
	                Do While nKogame < objCurOyagame.KoGames.Count

	                    With objCurOyagame.KoGames(nKogame)
	                        If .IsClsCash = False Or .Disabled = True Then
	                            nKogame += 1
	                            Continue Do
	                        End If
	                    End With

	                    objCash = objCurOyagame.KoGames(nKogame).ToClsCash
	                    Exit Do

	                Loop

	                If objCash Is Nothing Then
	                    objCurOyagame = objCurOyagame.Next
	                    Continue Do
	                End If

	                If objCash.IsPlacedCash = True Then
	                    objCurOyagame = objCurOyagame.Next
	                    Continue Do
	                End If

	                Return objCurOyagame



	                objCurOyagame = objCurOyagame.Next

	            Loop

	            Return Nothing

	        End Function

        End Class









        Private mstFileLists() As stFileList
        Private mBlockChains As clsBlockChains
        Private mCashSize As Integer


        Friend Function Encode(ByVal strFileListName As String) As Boolean
            Dim blRet As Boolean

            blRet = GetFileList(strFileListName)
            If blRet = False Then
                Return False
            End If

            Dim nFileCnt As Integer

            nFileCnt = 0
            Do While nFileCnt < mstFileLists.Length


                ' 前方参照情報作成
                ' キャッシュ最適化(あふれた場合のみ)
                ' ハフマン符号化
                blRet = Encode_OneFile(nFileCnt)


                ' 一つのリストに対して圧縮処理を行う

                nFileCnt += 1
            Loop

        End Function


        Friend Function Encode_OneFile(ByVal nFileNo As Integer) As Boolean

            Dim bRet As Boolean

            ' とりあえず.byte,.word形式のファイルから１つの親カメにRawDataを確保してそこに全部置く
            bRet = LoadAsmFileRawData(nFileNo)
            If bRet = False Then
                Return False
            End If

            ' ブロックチェーンの中を、2バイト以上の参照フレームに置きなおす
            Call SpiritemBlockChainByReffer()


            ' 参照先が必要なキャッシュフレームを作成
            ' キャッシュが被っていたらそれを流用
            Call CreateCashFrameOnBlockChains()

            ' 他のキャッシュに包括可能なキャッシュを１つにまとめる
            Call RePointCanInCash()

            ' 同じ親亀内のキャッシュを一つにまとめる
            Call MergeCashesOnOneOyagame()


			' コスト高になりそうなリファレンスを削除
            Call DeleteLowRefference()

			' 部分置換によりキャッシュの再利用を図る


            ' キャッシュメモリイメージを作成
            Call CreateCashImage(Me.mCashSize)

            Return True

        End Function




        Friend Function GetFileList(ByVal strFileListName As String) As Boolean


            Dim sr As System.IO.StreamReader
            Dim strLine As String
            Dim strHex As String
            Dim nFileCnt As Integer
            Dim strTrim() As Char = {" "}
            Dim strFileListPath As String
            Dim strPath As String
            Dim strRelativeFileName As String

            Try
                sr = New System.IO.StreamReader( _
                   strFileListName)

            Catch e As System.Exception
                ' とりあえず何もしない。
                Return False
            End Try

            strFileListPath = System.IO.Path.GetDirectoryName( _
               strFileListName)

            Dim nPos As Integer

            strLine = sr.ReadLine()
            If strLine Is Nothing Then
                System.Windows.Forms.MessageBox.Show( _
                 "圧縮ファイル一覧ファイルに何もありません。")
                sr.Close()
                sr.Dispose()
                sr = Nothing
                Return False
            End If

            nPos = strLine.IndexOf("DecoderCashSize=")
            If nPos < 0 Then
                System.Windows.Forms.MessageBox.Show( _
                 "デコーダ側キャッシュサイズ指定がありません。ファイル先頭に指定して下さい。")
                sr.Close()
                sr.Dispose()
                sr = Nothing
                Return False
            End If

            strHex = strLine.Substring(16)
            strHex = strHex.TrimStart(strTrim)
            Try
                'console.Writeline( "GetFileList DecoderCashSize=    StrHex=" & strHex )
                Me.mCashSize = _
                 System.Convert.ToUInt16(strHex, 16)
            Catch e As System.Exception
                System.Windows.Forms.MessageBox.Show( _
                 "DecoderCashSize= の16進数が読めません。")
                sr.Close()
                sr.Dispose()
                sr = Nothing
                Return False
            End Try


            nFileCnt = 0
            strLine = sr.ReadLine()
            Do While strLine IsNot Nothing

                ' これで読めるかなぁ…。
                strLine = strLine.Trim(strTrim)
                strPath = System.IO.Path.GetDirectoryName(strLine)
                strRelativeFileName = _
                 System.IO.Path.Combine( _
                   strFileListPath, strPath)
                strRelativeFileName = _
                 System.IO.Path.Combine(strRelativeFileName, _
                   System.IO.Path.GetFileName(strLine))

                If System.IO.File.Exists(strRelativeFileName) = True Then
                    nFileCnt += 1
                Else
                    Console.WriteLine("GetFileList Warning:File not found file=" & strLine)
                End If

                strLine = sr.ReadLine()
            Loop

            sr.Close()
            sr.Dispose()
            sr = Nothing

            If mstFileLists IsNot Nothing Then
                mstFileLists = Nothing
            End If
            mstFileLists = System.Array.CreateInstance( _
               GetType(stFileList), nFileCnt)

            sr = New System.IO.StreamReader( _
               strFileListName)


            ' DecoderCashSize= を読み飛ばす
            strLine = sr.ReadLine()
            Do While strLine IsNot Nothing

                strLine = strLine.Trim(strTrim)
                strPath = System.IO.Path.GetDirectoryName(strLine)
                strRelativeFileName = _
                 System.IO.Path.Combine( _
                   strFileListPath, strPath)

                strRelativeFileName = _
                 System.IO.Path.Combine(strRelativeFileName, _
                   System.IO.Path.GetFileName(strLine))


                If System.IO.File.Exists(strRelativeFileName) = True Then

                    mstFileLists(nFileCnt).FileName = _
                     System.IO.Path.GetFileName(strLine)
                    mstFileLists(nFileCnt).Path = _
                     System.IO.Path.GetDirectoryName(strLine)
                    mstFileLists(nFileCnt).NativeFileName = strLine

                    nFileCnt += 1
                End If
                strLine = sr.ReadLine()
            Loop

            sr.Close()
            sr.Dispose()
            sr = Nothing

            Return True

        End Function



        Private Function LoadAsmFileRawData(ByVal nFileNo As Integer) As Boolean

            Dim sr As System.IO.StreamReader

            ' 1バイトずつ読み込みながらキャッシュ作成
            Try
                sr = New System.IO.StreamReader( _
                   mstFileLists(nFileNo).NativeFileName)
            Catch e As System.Exception
                System.Windows.Forms.MessageBox.Show( _
                 "ファイル " & mstFileLists(nFileNo).NativeFileName & _
                 "が開けません。")
                Return False
            End Try


            Dim strLine As String
            Dim strTrim() As Char = {" "}
            Dim nByteCnt As Integer

            nByteCnt = 0

            strLine = sr.ReadLine()
            Do While strLine IsNot Nothing


                strLine = sr.ReadLine().Trim(strTrim).ToLower()

                If strLine.StartsWith(";") = True Then
                    strLine = sr.ReadLine()
                    Continue Do
                End If




                If strLine.StartsWith(".word") = True Then

                    Dim wRead As System.UInt16
                    strLine = strLine.Substring(6).Trim(strTrim)
                    Dim strHex As String
                    Dim nPos As Integer


                    Do While strLine.Length > 0
                        nPos = strLine.IndexOf(",")
                        If nPos > 0 Then
                            strHex = strLine.Substring(0, nPos)
                        Else
                            strHex = strLine
                            nPos = strLine.Length
                        End If

                        If strHex.StartsWith("$") = True Then
                            Try
                                wRead = System.Convert.ToUInt16(strHex.Substring(1), 16)
                            Catch err As System.Exception
                                ' 次を読む
                                strLine = strLine.Substring(nPos)
                                Continue Do
                            End Try
                        Else
                            Try
                                wRead = System.Convert.ToUInt16(strHex, 10)
                            Catch err As System.Exception
                                ' 次を読む
                                strLine = strLine.Substring(nPos)
                                Continue Do
                            End Try
                        End If
                        nByteCnt += 2


                        strLine = strLine.Substring(nPos)
                    Loop


                    GoTo CreateCashAndLoadAsm_ReadNextLine
                End If



                If strLine.StartsWith(".byte") = True Then


                    Dim bytRead As System.Byte
                    strLine = strLine.Substring(6).Trim(strTrim)
                    Dim strHex As String
                    Dim nPos As Integer


                    Do While strLine.Length > 0
                        nPos = strLine.IndexOf(",")
                        If nPos > 0 Then
                            strHex = strLine.Substring(0, nPos)
                        Else
                            strHex = strLine
                            nPos = strLine.Length
                        End If

                        If strHex.StartsWith("$") = True Then
                            Try
                                bytRead = System.Convert.ToByte(strHex.Substring(1), 16)
                            Catch err As System.Exception
                                ' 次を読む
                                strLine = strLine.Substring(nPos)
                                Continue Do
                            End Try
                        Else
                            Try
                                bytRead = System.Convert.ToByte(strHex, 10)
                            Catch err As System.Exception
                                ' 次を読む
                                strLine = strLine.Substring(nPos)
                                Continue Do
                            End Try
                        End If
                        nByteCnt += 1


                        strLine = strLine.Substring(nPos)
                    Loop

                    GoTo CreateCashAndLoadAsm_ReadNextLine
                End If

CreateCashAndLoadAsm_ReadNextLine:
                strLine = sr.ReadLine()
            Loop

            sr.Close()
            sr.Dispose()
            sr = Nothing




            ' 最初にバイトの配列１つだけのフレームを用意
            mBlockChains = New clsBlockChains()
            mBlockChains.PreUnzipData = System.Array.CreateInstance( _
                GetType(System.Byte), nByteCnt)

#If 0 Then
            ' 旧コード
            Dim objRawData As New clsRawData()
            objRawData.Pos = 0
            objRawData.Length = nByteCnt
            objRawData.Parent = mBlockChains(0)

            mBlockChains(0).KoGames.Add(objRawData)
#End If
            Dim objFrame As New clsFrame()
            With objFrame
                .RawOffSet = 0
                .Length = nByteCnt
            End With


            Try
                sr = New System.IO.StreamReader( _
                   mstFileLists(nFileNo).NativeFileName)
            Catch e As System.Exception
                System.Windows.Forms.MessageBox.Show( _
                 "ファイル " & mstFileLists(nFileNo).NativeFileName & _
                 "の2度目が開けません。")
                Return False
            End Try



            nByteCnt = 0

            ' バイナリテキストから配列に押し込む
            strLine = sr.ReadLine()
            Do While strLine IsNot Nothing


                strLine = sr.ReadLine().Trim(strTrim).ToLower()

                If strLine.StartsWith(";") = True Then
                    strLine = sr.ReadLine()
                    Continue Do
                End If


                If strLine.StartsWith(".word") = True Then

                    Dim wRead As System.UInt16
                    strLine = strLine.Substring(6).Trim(strTrim)
                    Dim strHex As String
                    Dim nPos As Integer


                    Do While strLine.Length > 0
                        nPos = strLine.IndexOf(",")
                        If nPos > 0 Then
                            strHex = strLine.Substring(0, nPos)
                        Else
                            strHex = strLine
                            nPos = strLine.Length
                        End If

                        If strHex.StartsWith("$") = True Then
                            Try
                                wRead = System.Convert.ToUInt16(strHex.Substring(1), 16)
                            Catch err As System.Exception
                                ' 次を読む
                                strLine = strLine.Substring(nPos)
                                Continue Do
                            End Try
                        Else
                            Try
                                wRead = System.Convert.ToUInt16(strHex, 10)
                            Catch err As System.Exception
                                ' 次を読む
                                strLine = strLine.Substring(nPos)
                                Continue Do
                            End Try
                        End If


                        mBlockChains.PreUnzipData(nByteCnt) = _
                           CByte(wRead And &HFF)

                        mBlockChains.PreUnzipData(nByteCnt + 1) = _
                            CByte((wRead And &HFF00) >> 8)

                        nByteCnt += 2


                        strLine = strLine.Substring(nPos)
                    Loop


                    GoTo CreateCashAndLoadAsm_ReadNextLine_2
                End If



                If strLine.StartsWith(".byte") = True Then


                    Dim bytRead As System.Byte
                    strLine = strLine.Substring(6).Trim(strTrim)
                    Dim strHex As String
                    Dim nPos As Integer


                    Do While strLine.Length > 0
                        nPos = strLine.IndexOf(",")
                        If nPos > 0 Then
                            strHex = strLine.Substring(0, nPos)
                        Else
                            strHex = strLine
                            nPos = strLine.Length
                        End If

                        If strHex.StartsWith("$") = True Then
                            Try
                                bytRead = System.Convert.ToByte(strHex.Substring(1), 16)
                            Catch err As System.Exception
                                ' 次を読む
                                strLine = strLine.Substring(nPos)
                                Continue Do
                            End Try
                        Else
                            Try
                                bytRead = System.Convert.ToByte(strHex, 10)
                            Catch err As System.Exception
                                ' 次を読む
                                strLine = strLine.Substring(nPos)
                                Continue Do
                            End Try
                        End If

                        mBlockChains.PreUnzipData(nByteCnt) = bytRead

                        nByteCnt += 1


                        strLine = strLine.Substring(nPos)
                    Loop

                    GoTo CreateCashAndLoadAsm_ReadNextLine_2
                End If

CreateCashAndLoadAsm_ReadNextLine_2:
                strLine = sr.ReadLine()
            Loop




            Return True

        End Function




        ' ハッシュを作る
        Private Sub SpiritemBlockChainByReffer()

            Dim nByteCnt As Integer
            Dim nDataSize As Integer
            Dim objArrayHash As clsArrayHash(Of clsByteKey, Integer)


            objArrayHash = New clsArrayHash(Of clsByteKey, Integer)

            Dim bytLast As System.Byte
            Dim objKey As clsByteKey

            Dim nBlockNo As Integer
            Dim bytOriginalData() As System.Byte
            Dim nOrigPos As Integer

            Dim objFrame As clsFrame

            objFrame = Me.mBlockChains.Item(0)

            nDataSize = mBlockChains.PreUnzipData.Length

            bytOriginalData = mBlockChains.PreUnzipData
            nOrigPos = 0

            If bytOriginalData.Length <= 1 Then
                ' 何もしない
                Exit Sub
            End If

            nByteCnt = 1
            objKey = New clsByteKey()
            objKey.low = mBlockChains.PreUnzipData(0)
            objKey.high = mBlockChains.PreUnzipData(1)
            nBlockNo = 0

            objArrayHash.Add(objKey, 0)

            nOrigPos += 1
            bytLast = objKey.low


            Do While nByteCnt < bytOriginalData.Length
                objKey = New clsByteKey()
                objKey.low = bytLast
                objKey.high = bytOriginalData(nByteCnt)

                bytLast = bytOriginalData(nByteCnt)

                If objArrayHash.Contains(objKey) = True Then

                    ' 何バイト一致するか調べる
                    Dim nMatch As Integer
                    Dim nMatchMax As Integer
                    Dim nRefPos As Integer
                    Dim nRefPosMost As Integer

                    Dim glList As System.Collections.Generic.List(Of Integer)
                    Dim nListNo As Integer = 0
                    glList = objArrayHash(objKey)

                    nMatchMax = -1
                    Do While nListNo < glList.Count
                        nRefPos = glList(nListNo)

                        If nByteCnt - nRefPos = 1 Then
                            ' 一個前のは参照扱いにしない
                            ' AAA とかの3文字連続データ対策
                        Else

                            nMatch = 2
                            Do While bytOriginalData(nByteCnt - 1 + nMatch) = bytOriginalData(nRefPos + nMatch)
                                nMatch += 1


                                If (bytOriginalData.Length >= nByteCnt - 1 + nMatch) Or _
                                   (bytOriginalData.Length >= nRefPos + nMatch) Then
                                    Exit Do
                                End If
                            Loop
                            If nMatch >= 3 And nMatchMax < nMatch Then
                                nRefPosMost = nRefPos
                                nMatchMax = nMatch
                            End If

                        End If

                        nListNo += 1
                    Loop

                    If nMatchMax > 0 Then

                        If nMatchMax >= Me.mCashSize Then
                            ' キャッシュオーバー
                            ' 自己連続参照以外は認めない
                            If nRefPosMost + nMatchMax >= nByteCnt - 1 And _
                             nRefPosMost + nMatchMax < nByteCnt - 1 + nMatchMax Then
                                ' 連続自己参照なら
                            Else

                                '・・・・
                                ' 参照を複数に分割した方がいいのかな？？？
                                ' どう処理したらいいか分からんｗ
                                ' レベル評価を含めてとりあえず
                                ' キャッシュサイズギリギリで入れておけばいいんじゃないか？
                                nMatchMax = Me.mCashSize
                            End If


                        End If



                        ' 変えるフレーム、
                        ' オリジナルデータの位置、サイズ
                        ' 参照先の位置
                        mBlockChains.ChangeFrame_RawToReffer( _
                            mBlockChains.ItemLast, _
                            nByteCnt - 1, nMatchMax, nRefPosMost)

                        ' 参照先のキャッシュ作って、
                        ' 同一参照先・参照サイズだったら同じキャッシュを参照するようにする

                        ' キャッシュ一覧を作成する

                        'キャッシュの優先度をついでに計算しとく

                        '参照したら圧縮後サイズが大きくなりそうなキャッシュはパスする
                        ' ( 参照回数が多くないと削除)


                        ' なんだこりゃ？？？
                        ' Reffer 参照中って保存命令出来ないからだっけ？
                        ' 2バイトずつ全部ハッシュ作らないと意味ないような？
                        nByteCnt += nMatchMax
                    End If

                Else
                    objArrayHash.Add(objKey, nByteCnt - 1)
                End If


                nByteCnt += 1
            Loop

            mBlockChains.mobjArrayHash = objArrayHash

        End Sub

        ' 
        Private Sub CreateCashFrameOnBlockChains()

            Dim nBlock As Integer
            Dim objCurFrame As clsFrame

            nBlock = 0
            objCurFrame = mBlockChains(0)
            Do While objCurFrame IsNot Nothing


                For Each objKoGame As clsKoGame In objCurFrame.KoGames
                    If objKoGame.IsClsReffer = False Then
                        Continue For
                    End If

                    Dim objReffer As clsReffer
                    objReffer = objKoGame.ToClsReffer
                    ' 参照先フレームを分割してキャッシュ化
                    ' 参照だったらどうしよう？
                    Dim nOyagame As Integer
                    Dim objAddedOyagame As clsOyaGame = Nothing
                    Dim nReffering As Integer
                    Dim nOyagameTop As Integer
                    Dim nOyagameEnd As Integer

                    nOyagame = 0
                    nReffering = mBlockChains.OyaGames.IndexOf(objCurOyamage)
                    Do While nOyagame < nReffering

                        mBlockChains(nOyagame).GetPositions(nOyagameTop, nOyagameEnd)

                        If objReffer.ToOffset < nOyagameTop Or _
                         objReffer.ToOffset > nOyagameEnd Then
                            nOyagame += 1
                            Continue Do
                        End If

                        ' 変換対象のフレーム発見
                        objAddedOyagame = mBlockChains(nOyagame)
                        Exit Do

                        nOyagame += 1
                    Loop


                    If objAddedOyagame.IsClsRawData Then

                        ' 
                        Dim objCash As New clsCashed()
                        With objCash
                            .RawOffset = objReffer.ToOffset
                            .Length = objReffer.Length
                        End With

                        objReffer.Reffer = objCash
                        objCash.AddReffed(objReffer)


                        objCash.Parent = objAddedOyagame
                        objAddedOyagame.KoGames.Add(objCash)
                        objAddedOyagame.DropLength()

                        ' キャッシュを流用
                        If nOyagameTop > nCashNewPos Then
                            ' 前の親亀フレームの長さを調整
                            clsBlockChains.CutOyagameRawDataSize_Top( _
                                            objAddedOyagame, nCashNewPos, _
                                            nOyagameTop - nCashNewPos, _
                                            Me.mBlockChains)
                        End If
                        ' 混在フレームだと削除する長さが間違ってる気がする。
                        If nOyagameEnd < nCashNewPosEnd Then
                            ' 後ろの親亀フレームの長さを調整
                            clsBlockChains.CutOyagameRawDataSize_End( _
                                         objAddedOyagame, nOyagameEnd, _
                                          nCashNewPosEnd - nOyagameEnd, _
                                          Me.mBlockChains)

                        End If
                    End If

                    ' キャッシュがあったらそれを流用
                    Dim objRawDataTemp As clsRawData = Nothing
                    Dim objCashTemp As clsCashed = Nothing
                    Dim objRefferTemp As clsReffer = Nothing
                    Dim bCashDone As Boolean
                    Dim bRefferDone As Boolean
                    Dim bErr As Boolean
                    Dim nKoGame As Integer

                    bCashDone = False
                    bRefferDone = False
                    objCashTemp = Nothing
                    objRefferTemp = Nothing
                    bErr = False
                    nKoGame = 0


                    Do While nKoGame < objAddedOyagame.KoGames.Count

                        With objAddedOyagame.KoGames(nKoGame)
                            If .IsClsRawData Then
                                objRawDataTemp = .ToClsRawData
                                Exit Do
                            ElseIf .IsClsCash Then
                                ' これ上書きされないかな・・・心配だ。
                                If objCashTemp IsNot Nothing Then
                                    System.Console.WriteLine("clsDelfGen:CreateCashFrameOnBlockChains  ProgramError!:  キャッシュが親亀に二つあるよ！")
                                    bErr = True
                                    Exit Do
                                End If
                                objCashTemp = .ToClsCash
                            ElseIf .IsClsReffer Then








                                If objRefferTemp IsNot Nothing Then
                                    System.Console.WriteLine("clsDelfGen:CreateCashFrameOnBlockChains  ProgramError!:  参照が親亀に二つあるよ！")
                                    bErr = True
                                    Exit Do
                                End If
                                objRefferTemp = .ToClsReffer
                            End If
                        End With
                        nKoGame += 1
                    Loop

                    If bErr Then
                        objCurOyamage = objCurOyamage.Next
                        Continue Do
                    End If


                    Dim nCashNewPos As Integer
                    Dim nCashNewPosEnd As Integer
                    Dim nCashNewLength As Integer

                    If objCashTemp IsNot Nothing Then

                        nCashNewPos = objReffer.ToOffset
                        nCashNewPosEnd = objReffer.ToOffset + objReffer.Length
                        nCashNewLength = objReffer.Length


                        '     ---------------------   足したいcash

                        '        ------------         cash
                        '          ------------       reffer

                        If objRefferTemp IsNot Nothing Then
                            ' キャッシュを用意すべき所が、既にキャッシュがあってさらに
                            ' 参照期間中の場合
                            ' キャッシュをリファーの先頭まで伸ばす
                            ' ( 参照期間中は保存命令が出来ないから、参照命令の前に保存命令をやるため)
                            ' ケツは別に伸ばさないでいい
                            nCashNewPos = System.Math.Min(nCashNewPos, objRefferTemp.FromOffset)

                        End If
                        nCashNewPos = System.Math.Min(nCashNewPos, objCashTemp.RawOffset)
                        nCashNewPosEnd = System.Math.Max(nCashNewPosEnd, _
                                                         objCashTemp.RawOffset + objCashTemp.Length)
                        nCashNewLength = nCashNewPosEnd - nCashNewPos

                        ' キャッシュを流用
                        If nOyagameTop > nCashNewPos Then
                            ' 前の親亀フレームの長さを調整
                            clsBlockChains.CutOyagameRawDataSize_Top( _
                                            objAddedOyagame, nCashNewPos, _
                                            nOyagameTop - nCashNewPos, _
                                            Me.mBlockChains)
                        End If
                        ' 混在フレームだと削除する長さが間違ってる気がする。
                        If nOyagameEnd < nCashNewPosEnd Then
                            ' 後ろの親亀フレームの長さを調整
                            clsBlockChains.CutOyagameRawDataSize_End( _
                                         objAddedOyagame, nOyagameEnd, _
                                          nCashNewPosEnd - nOyagameEnd, _
                                          Me.mBlockChains)

                        End If
                        ' 流用
                        objCashTemp.Length = nCashNewLength
                        objCashTemp.RawOffset = nCashNewPosEnd

                        objReffer.Reffer = objCashTemp
                        Call objCashTemp.AddReffed(objReffer)

                        bCashDone = True

                        objCurOyamage = objCurOyamage.Next
                        Continue Do
                    End If


                    nCashNewPos = objReffer.ToOffset
                    nCashNewPosEnd = objReffer.ToOffset + objReffer.Length
                    nCashNewLength = objReffer.Length


                    '     ---------------------   足したいcash

                    '        ------------         cash
                    '          ------------       reffer

                    If objRefferTemp IsNot Nothing Then
                        ' 参照期間中だったらキャッシュ位置を前にずらす
                        ' ( 参照期間中は保存命令が出来ないから、参照命令の前に保存命令をやるため)
                        ' ケツは別に伸ばさないでいい
                        nCashNewPos = System.Math.Min(nCashNewPos, objRefferTemp.FromOffset)

                        nCashNewLength = nCashNewPosEnd - nCashNewPos

                        ' キャッシュを流用
                        If nOyagameTop > nCashNewPos Then
                            ' 前の親亀フレームの長さを調整
                            clsBlockChains.CutOyagameRawDataSize_Top( _
                                            objAddedOyagame, nCashNewPos, _
                                            nOyagameTop - nCashNewPos, _
                                            Me.mBlockChains)
                        End If

                    End If

                    Dim objNewCash As New clsCashed
                    With objNewCash
                        .RawOffset = nCashNewPos
                        .Length = nCashNewLength
                    End With

                    objReffer.Reffer = objNewCash
                    objNewCash.AddReffed(objReffer)


                    objNewCash.Parent = objAddedOyagame
                    objAddedOyagame.KoGames.Add(objNewCash)
                    objAddedOyagame.DropLength()

                Next


                objCurOyamage = objCurOyamage.Next
            Loop

        End Sub


        Private Sub RePointCanInCash()

            ' キャッシュ同士の中身の比較
            ' キャッシュの包括一致性があるならまとめる？　～＞ハッシュ使ってるから必要なし
            '
            ' キャッシュ同士でかぶってるのとか似てるの
            ' を調べようと思ったけど別にいいか…。

            ' AAABBBBBCCCCC
            ' AAABBBBBDDDDD    先頭だけ一致する。

            ' AAABBBCCC   BBBCCC
            '    BBBCCC           最初のを参照する。

            ' Cash:BBBCCC   Cash:AAABBBCCC
            '  Ref:BBBCCC           最初のを参照する。
            '                       これは後ろのを参照すれば最適化出来る。
            '
            ' こーゆーケースだと
            ' プログラム的には「キャッシュ同士で包括性があるか」
            ' を見ればいい？
            ' Cash N vs N をお互いに確認・・・・。
            ' そりゃ無理だわな。

            Dim lCashes As System.Collections.Generic.List(Of clsCashed)

            lCashes = New System.Collections.Generic.List(Of clsCashed)(0)

            Dim objCurOyagame As clsOyaGame = mBlockChains(0)
            Do While objCurOyagame IsNot Nothing

                If objCurOyagame.IsClsRawData = True Then
                    objCurOyagame = objCurOyagame.Next
                    Continue Do
                End If


                For Each objKogame As clsKoGame In objCurOyagame.KoGames
                    If objKogame.IsClsCash = False Then
                        Continue For
                    End If
                    If objKogame.Disabled Then
                        Continue For
                    End If

                    lCashes.Add(objKogame.ToClsCash)

                Next

                objCurOyagame = objCurOyagame.Next
            Loop

            Dim nCashCnt As Integer
            Dim bytData() As Byte

            bytData = mBlockChains.PreUnzipData

            Dim lCashHits As New System.Collections.Generic.List(Of clsCashed)(0)
            nCashCnt = 0
            Do While nCashCnt < lCashes.Count

                ' mBlockChains.mobjArrayHash
                Dim nCashDiff As Integer

                If lCashes(nCashCnt).Disabled Then
                    nCashCnt += 1
                    Continue Do
                End If

                lCashHits = New System.Collections.Generic.List(Of clsCashed)(0)

                nCashDiff = 0
                Do While nCashDiff < lCashes.Count
                    If nCashCnt = nCashDiff Then
                        nCashDiff += 1
                        Continue Do
                    End If

                    If lCashes(nCashDiff).Disabled Then
                        nCashDiff += 1
                        Continue Do
                    End If

                    If lCashes(nCashCnt).Length > lCashes(nCashDiff).Length Then
                        nCashDiff += 1
                        Continue Do
                    End If


                    ' reffer より後のキャッシュだったら参照出来ないので
                    ' 無視する
                    Dim bNotUse As Boolean
                    bNotUse = False
                    For Each objRef As clsReffer In lCashes(nCashCnt).Reffereds
                        If objRef.FromOffset <= lCashes(nCashDiff).RawOffset Then
                            ' 後方参照は出来ないのでこのキャッシュの最適化は行わない
                            bNotUse = True
                            Exit For
                        End If
                    Next
                    If bNotUse Then
                        nCashDiff += 1
                        Continue Do
                    End If

                    ' System.Array.IndexOf( 検索範囲、サーチするアイテム、StartIndex, count
                    '							StartIndex～StartIndex+count までの範囲を検索
                    Dim nPosFound As Integer
                    nPosFound = System.Array.IndexOf(mBlockChains.PreUnzipData, _
                                              mBlockChains.PreUnzipData(lCashes(nCashCnt).RawOffset), _
                                              lCashes(nCashDiff).RawOffset, _
                                              lCashes(nCashDiff).Length)
                    If nPosFound < 0 Then
                        nCashDiff += 1
                        Continue Do
                    End If

                    Dim nMatch As Integer
                    nMatch = 1
                    Do While bytData(nPosFound + nMatch) = _
                       bytData(lCashes(nCashCnt).RawOffset + nMatch)
                        nMatch += 1
                        If nMatch >= lCashes(nCashCnt).Length Then
                            Exit Do
                        End If
                    Loop

                    If nMatch < lCashes(nCashCnt).Length Then
                        nCashDiff += 1
                        Continue Do
                    End If



                    ' 包括キャッシュ発見！
                    ' lCashes( nCashCnt ) は lCashes( nCashDiff ) にまるまる入る
                    lCashHits.Add(lCashes(nCashDiff))


                    nCashDiff += 1
                Loop

                If lCashHits.Count = 0 Then
                    nCashCnt += 1
                    Continue Do
                End If

                ' ２つ以上包括キャッシュあったらどうすんだろ・・・・。
                ' コストによるんじゃねぇの？
                ' 最適化フェーズの際にもう一度評価する必要あるだろこれ
                For Each objCashCanIn As clsCashed In lCashHits
                    lCashes(nCashCnt).AddCanInCash(objCashCanIn)
                Next

                If lCashHits.Count >= 1 Then
                    ' 1個だけだったら構わず合体する。
                    ' 2個あってもとりあえず合体する。
                    lCashes(nCashCnt).Disabled = True
                    lCashes(nCashCnt).DisabledReason = clsKoGame.DisabledReasons.CanInCashIsFound

                    For Each objRefTemp As clsReffer In lCashes(nCashCnt).Reffereds

                        Dim nPosFound As Integer

                        objRefTemp.Reffer = lCashHits(0)

                        nPosFound = System.Array.IndexOf(mBlockChains.PreUnzipData, _
                                                 mBlockChains.PreUnzipData(lCashes(nCashCnt).RawOffset), _
                                                 lCashHits(0).RawOffset, _
                                                 lCashHits(0).Length)
                        objRefTemp.ToOffset = lCashHits(0).RawOffset + nPosFound
                    Next

                    ' 全部ディスエーブルキャッシュだったらRawDataを足しとく
                    If lCashes(nCashCnt).Parent.GetLiveKoGameCnt = 0 Then

                        Dim objRawData As New clsRawData()

                        objRawData.Pos = lCashes(nCashCnt).RawOffset
                        objRawData.Length = lCashes(nCashCnt).Length
                        objRawData.Parent = lCashes(nCashCnt).Parent
                        objRawData.Parent.KoGames.Insert(0, objRawData)

                    End If
                End If



#If 0 Then
			Dim objKey		as clsByteKey
			objKey = new clsByteKey()
			objKey.low  = mBlockChains.PreUnzipData( lCashes( nCashCnt ).RawOffset     )
			objKey.high = mBlockChains.PreUnzipData( lCashes( nCashCnt ).RawOffset + 1 )
			objKey.blOneByte = false


			If objArrayHash.Contains( objKey ) = true Then

			End If
#End If

                nCashCnt += 1
            Loop




            ' 連続周期性があるものは例の「１つキャッシュ書いて、すぐにキャッシュ参照」
            ' に置換を試みる。
            ' 
            ' 例えば。
            '  今の BlockChain的には
            '  AAAB     は    Raw:AAAB
            '  AAAA     は    Raw:AA  Ref:-2文字前、長さ2
            '  AAAAA    は    Raw:AA  Ref:-2文字前、長さ3
            '  AAAAAA   は    Raw:AA  Ref:-2文字前、長さ4
            '  AAAAAAA  は    Raw:AA  Ref:-2文字前、長さ5
            ' ....という内部表現になっているはず。
            ' つまり、連続データ対策は何もしなくていいｗ

            '
            '  ABAA       は    Raw:ABAA
            '  ABAB       は    Raw:AB  Ref:-2文字前、長さ2
            '  ABABAB     は    Raw:AB  Ref:-2文字前、長さ4
            '  ABABABAB   は    Raw:AB  Ref:-2文字前、長さ6
            '  ABABABABAB は    Raw:AB  Ref:-2文字前、長さ8
            ' ....という内部表現になっているはず。
            ' つまり、連続データ対策は何もしなくていいｗ

            '  ABCAB       は   Raw:ABC Ref:-3文字前、長さ2
            '  ABCABC      は   Raw:ABC Ref:-3文字前、長さ3
            '  ABCABCABC   は   Raw:ABC Ref:-3文字前、長さ6
            ' つまり、連続データ対策は何もしなくていいｗ

        End Sub




        Private Sub MergeCashesOnOneOyagame()
            Dim objCurOyagame As clsOyaGame

            ' 場所が被ってるキャッシュフレームをもう合体する。
            ' キャッシュイメージ作る時に、長さが重複するから・・・。
            ' でも作るのちょっと早いような気もする。


            objCurOyagame = Me.mBlockChains(0)
            Do While objCurOyagame IsNot Nothing

                If objCurOyagame.IsClsRawData Then
                    objCurOyagame = objCurOyagame.Next
                    Continue Do
                End If

                Dim nKogame As Integer
                nKogame = 0
                Do While nKogame < objCurOyagame.KoGames.Count


                    If objCurOyagame.KoGames(nKogame).IsClsCash = False Then
                        nKogame += 1
                        Continue Do
                    End If

                    Dim objCurCash As clsCashed
                    objCurCash = objCurOyagame.KoGames(nKogame).ToClsCash

                    If objCurCash.Disabled Then
                        nKogame += 1
                        Continue Do
                    End If


                    Dim nKogameRef As Integer
                    nKogameRef = 0
                    Do While nKogameRef < objCurOyagame.KoGames.Count
                        If nKogame = nKogameRef Then
                            nKogameRef += 1
                            Continue Do
                        End If

                        Dim objCashVanish As clsCashed
                        objCashVanish = objCurOyagame.KoGames(nKogameRef).ToClsCash
                        If objCashVanish.IsClsCash = False Then
                            nKogameRef += 1
                            Continue Do
                        End If

                        ' キャッシュ合体処理

                        For Each objRef As clsReffer In objCashVanish.Reffereds
                            objRef.Reffer = objCurCash
                        Next
                        objCurCash.Disabled = True
                        objCurCash.DisabledReason = clsKoGame.DisabledReasons.CashInSameOyaGameIsMerged

                        ' 長さ調整
                        With objCurCash
                            .RawOffset = System.Math.Min( _
                             .RawOffset, _
                             objCashVanish.RawOffset)
                            Dim nPosEnd As Integer
                            nPosEnd = System.Math.Min( _
                              .RawOffset + .Length, _
                              objCashVanish.RawOffset + objCashVanish.Length)
                            .Length = nPosEnd - .RawOffset
                        End With

                        nKogameRef += 1
                    Loop

                    nKogame += 1
                Loop

                objCurOyagame = objCurOyagame.Next
            Loop
        End Sub

        ' 高コストになりそうな参照を削除しておく
        Private Sub DeleteLowRefference()

            Dim objCurOyagame As clsOyaGame

            objCurOyagame = Me.mBlockChains(0)
            Do While objCurOyagame IsNot Nothing

                If objCurOyagame.IsClsRawData Then
                    objCurOyagame = objCurOyagame.Next
                    Continue Do
                End If

                Dim objCash As clsCashed
                Dim nKogame As Integer
                nKogame = 0
                objCash = Nothing
                Do While nKogame < objCurOyagame.KoGames.Count

                    With objCurOyagame.KoGames(nKogame)
                        If .IsClsCash = False Or .Disabled = True Then
                            nKogame += 1
                            Continue Do
                        End If
                    End With
                    Dim objCurCash As clsCashed
                    objCurCash = objCurOyagame.KoGames(nKogame).ToClsCash

                    objCash = objCurCash
                    Exit Do
                Loop

                If objCash Is Nothing Then
                    objCurOyagame = objCurOyagame.Next
                    Continue Do
                End If


                ' 各ハフマン命令を 1.3 バイトで適当に見積もる。
                ' 保存命令： cash   当たり 1.3 * 3 バイト
                ' 参照命令： reffer 当たり 1.3 * 2 バイト

                ' RawData まんまの方が効率が良い場合は RawData に戻す。
                ' 複数参照の場合はその限りではなくなる。キャッシュ位置が同じ位置を参照する？

                Dim nRawUseByte As Integer
                Dim nRefferCnt As Integer
                Dim nSameRefferCnt As Integer
                Dim nSameRefferCnt2 As Integer

                Dim objpreReffer As clsReffer

                nRawUseByte = 0
                nRefferCnt = 0
                objpreReffer = Nothing
                nSameRefferCnt = 0
                nSameRefferCnt2 = 0
                For Each objReffer As clsReffer In objCash.Reffered
                    If objReffer.Diabled = True Then
                        Continue For
                    End If

                    nRawUseByte += objReffer.Length
                    nRefferCnt += 1

                    If objpreReffer Is Nothing Then
                        objpreReffer = objReffer
                    Else
                        If objReffer.Length = objpreReffer.Length And _
                         objReffer.ToOffset = objpreReffer.ToOffset Then
                            nSameRefferCnt += 1
                        Else
                            nSameRefferCnt = 0
                            objpreReffer = objReffer
                        End If

                        ' とりあえず上書きされないよう最大値を保存しとく。
                        If nSameRefferCnt2 < nSameRefferCnt Then
                            nSameRefferCnt2 = nSameRefferCnt
                        End If

                    End If
                Next



                Dim nRefferCost As Integer

                nRefferCost = 13

                ' 全く同じデータへの参照回数が極端に多ければ、１回あたりの参照コストは結構下がるはず？
                ' とりあえず全データの30%を超えるなら参照コストは極端に
                ' 下がると予想ｗ
                If nSameRefferCnt2 > 0 Then
                    If ((Me.mBlockChains.PreUnzipData / 10) * 3) < nSameRefferCnt2 * objpreReffer.Length Then
                        nRefferCost = 4
                    End If
                End If

                '   参照命令               保存命令
                'If nRefferCnt * 1.3 * 2 + 1.3 * 3     > nRawUseByte Then
                If nRefferCnt * nRefferCost * 2 + 13 * 3 > nRawUseByte * 10 Then
                    ' 参照の方がコスト高なので削除する

                    clsBlockChains.DisableCash( _
                                 objCash, _
                                 clsKoGame.DisabledReasons.MaybeHighCostRefferCashIsDeleted, _
                                 Me.mBlockChains)


                End If

            Loop


        End Sub


        ' キャッシュイメージを作成し途中でサイズオーバーしてないか確認
        Private Sub CreateCashImage(ByVal nCashSize As Integer)

            ' とりあえず・・・。
            ' 配置は、
            '   ・寿命が特に短い参照、参照回数が多い物は先頭付近に置く。
            '   ・参照距離、頻度が長いものは後ろ詰めで置く。
            '   こんなんでいいんじゃない？
            '   
            '   自己循環参照はバイト数によらず優先的に使い、逆に参照を解除してまでして
            '	 循環参照を行う。
            '   キャッシュが全面オーバーしても構わない。
            '     逆にキャッシュ使い切るほどだったら、参照命令を何回か繰り返して
            '     意図的にキャッシュを残す方法も考えられる。
            '     圧縮率次第？
            '

            ' 暫定的に重さを評価。
            '  - 参照頻度 x 参照バイト数 x 参照距離の逆数( 
            '
            '
            Dim objImages As clsCashImageManager

            Dim objPosHash As clsMultiSortedList

            objImages = New clsCashImageManager()
            Me.mBlockChains.mCashImageManager = objImages
            objImages.UnzipDataSize = Me.mBlockChains.PreUnzipData.Length
            objImages.CashSize = nCashSize

            objPosHash = New clsMultiSortedList()
            objImages.mCashPoitionIntend = objPosHash


            ' とりあえず頭から順にキャッシュ足していこうかな…。
            ' 場所は適当でいいかな？
            Dim objCurOyagame As clsOyaGame

            objCurOyagame = Me.mBlockChains(0)
            Do While objCurOyagame IsNot Nothing

                If objCurOyagame.IsClsRawData Then
                    objCurOyagame = objCurOyagame.Next
                    Continue Do
                End If

                Dim objCash As clsCashed
                Dim nKogame As Integer
                nKogame = 0
                objCash = Nothing
                Do While nKogame < objCurOyagame.KoGames.Count

                    With objCurOyagame.KoGames(nKogame)
                        If .IsClsCash = False Or .Disabled = True Then
                            nKogame += 1
                            Continue Do
                        End If
                    End With
                    Dim objCurCash As clsCashed
                    objCurCash = objCurOyagame.KoGames(nKogame).ToClsCash

                    objCash = objCurCash
                    Exit Do
                Loop

                If objCash Is Nothing Then
                    objCurOyagame = objCurOyagame.Next
                    Continue Do
                End If





                Dim objImage As clsCashImage

                objImages = New clsCashImageManager()




                objImage = New clsCashImage(objCash)
                objImage.DataLevel = 0
                For Each objRef As clsReffer In objImage.Reffereds
                    Dim nOneDataLevel As Integer

                    ' とりあえず、すごく近かったら100
                    ' 遠くなるほど値が小さくなるようにするか…。
                    ' 優先度が低くなるほど真っ先に解除されるようにする。
                    nOneDataLevel = (Me.mBlockChains.mCashImageManager.UnzipDataSize * 100)
                    nOneDataLevel /= objRef.FromOffset - objRef.ToOffset

                    nOneDataLevel *= objRef.Length

                    objImage.DataLevel += nOneDataLevel
                Next



                ' キャッシュケツから頭に戻る「循環キャッシュ」のコードが抜けてる。



                ' キャッシュの配置順序が決まらないｗ
                ' 入る場所を優先的に使って…。


                '
                '
                '  参照が多い場合、少ない場合とで
                '  参照の削除を行う。
                '   参照、保存のコストを仮計算。
                '  この段階でハフマン符号化によって
                '  全体コストを割り出す。
                '    ==>  キャッシュ配置・削除を後でやるのは
                '         効率が悪いと思うからｗ
                '
                ' HoleLength の利点
                '       そこそこキャッシュが配置され「穴」を
                '       探す為に考案された
                '		キャッシュ間がかなり空いている場合に
                '       有効
                ' TryAddCashImageの利点
                '       最初期のキャッシュ配置を前提
                '       キャッシュ寿命が全体的に短い場合に有効？
                '
                'objImages.TryAddCashImage(objImage)
                '

                ' 




                ' 暫定的なキャッシュイメージはこっちで作った
                ' 方がいいかな…。
                ' 一度仮のキャッシュイメージを作る方法は
                ' なんか間違ってる気がする
                ' けどとりあえず使う。
                Dim nUsedCashSize As Integer
                Dim nCashUsedTop As Integer
                Dim nCashUsedEnd As Integer
                Dim objCurentImage As New System.Collections.Generic.List(Of clsCashImage)(0)
                Dim objCanInsertPlaces As New System.Collections.Generic.List(Of clsCashImage)(0)

                nUsedCashSize = 0
                nCashUsedTop = objImages.CashSize
                nCashUsedEnd = 0
                With Nothing
                    Dim nCash As Integer = 0
                    Do While nCash < objImages.Images.Count

                        'If objImages(nCash).IsCashCross(nCashPos, objImage.Length) = False Then
                        '   ' この位置はまだいいらしい。
                        '   nCash += 1
                        '    Continue Do
                        'End If
                        If objImages(nCash).IsLive(objImage) = False Then
                            ' この位置はまだいいらしい。
                            nCash += 1
                            Continue Do
                        End If

                        nCashUsedTop = System.Math.Min(nCashUsedTop, objImages(nCash).CashOffset)
                        nCashUsedEnd = System.Math.Max(nCashUsedEnd, objImages(nCash).CashOffsetEnd - 1)
                        nUsedCashSize += objImages(nCash).Length

                        ' CashOffsetでソートしながら入れる。。。
                        'objCurentImage.Add(objImages(nCash))
                        Dim nIndex As Integer
                        nIndex = objCurentImage.BinarySearch(objImages(nCash), objImages(nCash))
                        If nIndex < 0 Then
                            nIndex *= -1
                        Else
                            ' まぁここ来る事はないはずだけど…。
                        End If
                        objCurrentImage.Insert(nIndex, objImages(nCash))
                        nCash += 1
                    Loop

                End With



                ' 連続自己参照でキャッシュを全て使い切ってしまう場合
                If objImages.IsCashOver(0, objImage.Length) = True Then

                    With Nothing
                        Dim bRet As Boolean
                        ' キャッシュサイズより大きい参照、循環自己参照の場合
                        bRet = Me.mBlockChains.mCashImageManager.CreateCashImage_CreateCashImageAndEvaluate( _
                               objImage, objCurentImage, _
                               Me.mBlockChains)
                        If bRet Then
                            ' 追加が出来ず Reffer を削除したか、既存のイメージのキャッシュを全部削除してその
                            ' Reffer を削除、単一キャッシュオーバーキャッシュを追加した。
                            ' キャッシュ未配置の先頭親亀を求め直す
                            objCurOyagame = Me.mBlockChains.mCashImageManager.CreateCashImage_GetOyagameTopUnlocateCash()
                            Continue Do
                        End If
                    End With

                End If




                ' キャッシュオーバーする場合
                If objImages.IsCashOver(nUsedCashSize, objImage.Length) = True Then

                    bRet = Me.mBlockChains.mCashImageManager.CreateCashImage_TryAddCashMemoryOveredCash( _
                           objImage, objCurentImage, _
                            Me.mBlockChains)
                    If bRet Then
                        objCurOyagame = Me.mBlockChains.mCashImageManager.CreateCashImage_GetOyagameTopUnlocateCash()
                        Continue Do
                    End If
                End If



                ' キャッシュ占有率が50%を超えたら「ホール穴」形式による
                ' 割り当てロジック
                ' 50% なら TryAddCashImage によるキャッシュ割り当て



                With Nothing
                    nCash = 1
                    Do While nCash < objCurrentImage.Count
                        objCurrentImage(nCash - 1).HoleLength = objCurrentImage(nCash).CashOffset - _
                                objCurrentImage(nCash - 1).CashOffsetEnd

                        If objCurrentImage(nCash - 1).HoleLength >= objImage.Length Then
                            objCanInsertPlaces.Add(nCash - 1)
                        End If
                        nCash += 1
                    Loop
                	objCurrentImage( objCurrentImage.Count-1 ).HoleLength = 
                End With


                ' キャッシュオーバーして先頭から続きを入れるロジックが
                ' 欠落してんだよな。


                ' キャッシュ占有率が低いときはどんどん移動する感じで以下のを使う
                objImages.TryAddCashImage(objImage)

                objCurOyagame = objCurOyagame.Next
            Loop


        End Sub




        ' CUIコマンドターミナルを実装ｗ
        Private Sub DebugCUIMode()

            Dim strInput As String

            Do
                Console.WriteLine(" > ")
                strInput = Console.ReadLine()

                If strInput = "q" Then
                    Exit Do
                End If

            Loop


        End Sub

        Friend Shared Sub ErrMsg(ByVal sMsg As String, ByVal objStackFrame As System.Diagnostics.StackFrame)
            System.Windows.Forms.MessageBox.Show(objStackFrame.ToString() & vbCrLf & sMsg)
        End Sub


    End Class





End Namespace
